(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = text; inactive; preserveAspect]
Copyright Alfred Clark, Jr., 1996
;[s]
3:0,1;28,0;29,2;34,-1;
3:1,18,13,Symbol,0,12,0,0,0;1,12,9,Courier,0,10,0,0,0;1,12,9,Symbol,0,10,0,0,0;
:[font = text; inactive; preserveAspect]


:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS
PART 2
:[font = subtitle; inactive; preserveAspect]
VERSION 10.2

:[font = subtitle; inactive; preserveAspect]
11.  PHASE PORTRAITS
:[font = text; inactive; preserveAspect]
    The function portrait creates a phase portrait from a given list of initial conditions.  It takes as arguments (1) intlist,a list of initial conditions, (2) t0, an initial time or a list of initial times, (3) h, the step size, (4) nsteps, the number of time steps, (5) the indices i and j specifying which components are to be plotted.  If t0 is an initial time, that time is used to start each integration.  If t0 is a list of times, they are used sequentially in performing the integration for the different initial conditions in intlist.  The function portrait3D does exactly the same thing, except in three dimensions.
     
:[font = input; preserveAspect]
portrait[intlist_,t0_,h_,nsteps_,i_,j_] := Module[
		{numint, glist,tlen,tdum},tlen = Length[t0];
		numint = Length[intlist];
		glist = {};
		Do [If[(tlen==0),(tdum=t0),(tdum=t0[[q]])]; 
			glist = Append[glist,graphcon[
				integrate[intlist[[q]],tdum,h,nsteps],i,j]],
			{q,1,numint}];
		Show[glist,Axes -> axon,PlotRange -> plrange,
			AxesOrigin -> axorg, 
			AxesLabel -> {statevec[[i]],statevec[[j]]},	
			PlotLabel -> plotlab,
			DisplayFunction -> 
			(If[display,$DisplayFunction,Identity]),
			AspectRatio -> asprat]]
				
:[font = input; preserveAspect]
portrait3D[intlist_,t0_,h_,nsteps_,i_,j_,k_] := Module[
		{numint, glist,tlen,tdum},tlen = Length[t0];
		numint = Length[intlist];
		glist = {};
		Do [If[(tlen==0),(tdum=t0),(tdum=t0[[q]])]; 
			glist = Append[glist,graphcon3[
				integrate[intlist[[q]],tdum,h,nsteps],i,j,k]],
			{q,1,numint}];
		Show[glist,Axes -> axon, Boxed -> True,
			PlotRange -> plrange,
			ViewPoint -> viewpt, 
			AxesLabel -> 
			{statevec[[i]],statevec[[j]],statevec[[k]]},	
			PlotLabel -> plotlab,
			DisplayFunction -> 
			(If[display,$DisplayFunction,Identity]),
			BoxRatios -> boxrat,
			SphericalRegion -> False]]
				
:[font = text; inactive; preserveAspect]
     Now we use portrait and portrait3D to define simple bifurcation routines.  These routines construct a sequence of phase portraits, one for each set of parameters in the list parmlist.
:[font = input; preserveAspect]
bifurc[intlist_,t0_,h_,nsteps_,i_,j_,parmlist_] := 
			(Print["Bifurcation sequence for parmlist = ", 
			        parmlist];
			Do[
				parmval = parmlist[[k]];
				portrait[intlist,t0,h,nsteps,i,j],
				{k,1,Length[parmlist]}])
				
:[font = input; preserveAspect]
bifurc3D[intlist_,t0_,h_,nsteps_,i_,j_,k_,parmlist_] := 
			(Print["Bifurcation sequence for parmlist = ", 
			        parmlist];
			Do[
				parmval = parmlist[[q]];
				portrait3D[intlist,t0,h,nsteps,i,j,k],
				{q,1,Length[parmlist]}])
				
:[font = text; inactive; preserveAspect]
     The routine phaseseq constructs a time-sequence of phase portraits at equal time intervals.  By animating the graph sequence produced, one gets a simulation of the actual construction of the phase portrait and a valid representation of the speed of the system point along the orbits presented.  The routine phaseseq3D does exactly the same thing for three-dimensional phase plots. 
:[font = input; preserveAspect]
phaseseq[initlist_,t0_,h_,nstepic_,npics_,i_,j_] :=
	Module[{bigsol,nsteps,tmin,tmax,startsol,tempoint,
			temptsize,delt,solpiece,lena,worklist,
			leadergraph,basegraph,leaderpt,dtsize},
	lena = Length[Dimensions[initlist]];
	If[(lena==1),(worklist={initlist}),(worklist=initlist)];
	dtsize = 0.02;		
	nsteps = nstepic*npics;
	delt = nstepic*h;
	startsol = Map[Prepend[#,t0]&,worklist];
	tempoint = pointcon;
	pointcon = False;
	temptsize = ptsize;
	ptsize = dtsize; 
	phaseplot[startsol,i,j];
	pointcon = tempoint;
	ptsize = temptsize;
	bigsol = Map[integrate[#,t0,h,nsteps]&,worklist];
	Do[(tmin = t0;tmax = tmin + q*delt;
		solpiece = Map[subsol[#,{tmin,tmax}]&,bigsol];
		display = False;
		basegraph = phaseplot[solpiece,i,j];
		tempoint = pointcon;
		pointcon = False;
		temptsize = ptsize;
		ptsize = dtsize;
		leaderpt = Map[Last[#]&,solpiece];
		leadergraph = phaseplot[leaderpt,i,j];
		display = True;
		pointcon = tempoint;
		ptsize = temptsize;
		show[{basegraph,leadergraph}];),{q,1,npics}]]
		
:[font = input; preserveAspect]
phaseseq3D[initlist_,t0_,h_,nstepic_,npics_,i_,j_,k_] :=
	Module[{bigsol,nsteps,tmin,tmax,startsol,tempoint,
			temptsize,delt,solpiece,lena,worklist,
			leadergraph,basegraph,leaderpt,dtsize},
	dtsize = 0.02;		
	lena = Length[Dimensions[initlist]];
	If[(lena==1),(worklist = {initlist}),(worklist = initlist)];		
	nsteps = nstepic*npics;
	delt = nstepic*h;
	startsol = Map[Prepend[#,t0]&,worklist];
	tempoint = pointcon;
	pointcon = False;
	temptsize = ptsize;
	ptsize = dtsize; 
	phaseplot3D[startsol,i,j,k];
	pointcon = tempoint;
	ptsize = temptsize;
	bigsol = Map[integrate[#,t0,h,nsteps]&,worklist];
	Do[(tmin = t0;tmax = tmin + q*delt;
		solpiece = Map[subsol[#,{tmin,tmax}]&,bigsol];
		display = False;
		basegraph = phaseplot3D[solpiece,i,j,k];
		tempoint = pointcon;
		pointcon = False;
		temptsize = ptsize;
		ptsize = dtsize;
		leaderpt = Map[Last[#]&,solpiece];
		leadergraph = phaseplot3D[leaderpt,i,j,k];
		display = True;
		pointcon = tempoint;
		ptsize = temptsize;
		show3D[{basegraph,leadergraph}];),{q,1,npics}]]
		
:[font = subtitle; inactive; preserveAspect; startGroup]
12.  LIMIT CYCLES
:[font = text; inactive; preserveAspect]
     Here we introduce a minor automation in the production of a limit cycle.  The object is to produce the pure limit cycle without the transients from an arbitrary startup point.  This is accomplished by performing two integrations.  The first integration starts from any guessed initial point.  The second integration, which is all that is saved, uses the final point of the first integration as an initial value.  Both integrations use the same number of user-specified time steps, nsteps, which must be large enough so that the first integration puts you on the limit cycle, and the second integration carries you through the cycle.
:[font = input; preserveAspect]
limcyc[initialvec_,t0_,h_,nsteps_] := Module[{tempans},
                tempans = integrate[initialvec,t0,h,nsteps];
                integrate[lastx,lastt,h,nsteps]]
                                  
:[font = text; inactive; preserveAspect]
     Once a pure limit cycle has been constructed, it is relatively easy to calculate the period.  The function period[cycsol] takes a solution list named cycsol from an autonomous system and calculates the period, with a resolution equal to the spacing h, by searching through the list and finding the first future point at which the solution is closest to the initial point.  It is essential that the solution list be purely periodic (no start-up transients) and that it contain at least three points beyond the full period.  This works only for autonomous systems.  
:[font = input; preserveAspect]
sqnorm[vec_] := Dot[vec,vec]	
:[font = input; preserveAspect]
period[sol_] := Module[{h,old,new,ind,ans,ruler,len},
	len = Length[sol];
	ruler = sqnorm[(Drop[sol[[1]],1]-Drop[sol[[5]],1])];
	h = First[sol[[2]]] - First[sol[[1]]];
	old = sqnorm[(Drop[sol[[1]],1]-Drop[sol[[2]],1])];
	new = sqnorm[(Drop[sol[[1]],1]-Drop[sol[[3]],1])];
	ind = 3;
	While[((new>old)&&(ind<(len-1))),
	  (old = new; ind = ind+1;
	  new = sqnorm[(Drop[sol[[1]],1]-Drop[sol[[ind]],1])])];
	While[(((new<old)||(new>ruler))&&(ind<(len-1))), 
	  (old = new; ind = ind+1;
	  new = sqnorm[(Drop[sol[[1]],1]-Drop[sol[[ind]],1])])];
	If[(ind<(len-1)),((ind-2)*h),
		(Print["Solution not periodic."])]]
	
:[font = text; inactive; preserveAspect]
     Often limit cycles depend on one or more parameters, and it is of interest to study how the cycle changes as the parameters change.  To make that process a little more convenient, we have defined a function limbifurc that constructs automatically a sequence of pure limit cycles for each set of parameter values in the list parmlist.  The function limbifurc3D does the same, except that it produces 3D plots.  
:[font = input; preserveAspect]
limbifurc[ivec_,t0_,h_,nsteps_,i_,j_,parmlist_] := 
			(Print["Limit cycles for parmlist = ", parmlist];
			Do[
				parmval = parmlist[[k]];
				phaseplot[limcyc[ivec,t0,h,nsteps],i,j],
				{k,1,Length[parmlist]}])
				
:[font = input; preserveAspect; endGroup]
limbifurc3D[ivec_,t0_,h_,nsteps_,i_,j_,k_,parmlist_] := 
			(Print["Limit cycles for parmlist = ", parmlist];
			Do[
				parmval = parmlist[[q]];
				phaseplot3D[limcyc[ivec,t0,h,nsteps],i,j,k],
				{q,1,Length[parmlist]}])
				
:[font = subtitle; inactive; preserveAspect; startGroup]
13.  INTERPOLATING FUNCTIONS
:[font = text; inactive; preserveAspect]
     The function buildinterp[sol] builds a list containing an interpolating function for each component of the state vector from the solution list named sol.  It uses the Mathematica routine Interpolation applied to appropriate parts of sol.  You may assign the functions to any vector of names, but you cannot use the state variables as function names.  
;[s]
3:0,0;172,1;183,0;357,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = input; preserveAspect; endGroup]
buildinterp[sol_] := Module[ {terplist},
				terplist = {};
					Do [ terplist = Append[terplist,
					 Interpolation[Map[pairgen[#,0,i]&,sol]]],
					 {i,1,Length[statevec]}];
				terplist ]
					
:[font = subtitle; inactive; preserveAspect; startGroup]
14.  LINEAR STABILITY
:[font = text; inactive; preserveAspect]
     The functions defined here facilitate the analysis of the stability of a known equilbrium point.  The routine dermat uses the current settings of statevec and slopevec to construct the derivative matrix of the system, with all state variables and parameters left as symbols.  The routine dermatval[eqstate] constructs the numerical derivative matrix at the point eqstate.  Any parameter symbols appearing either in eqstate or the derivative matrix are assigned values from the current setting of parmval.  The stability analysis can then be carried out using Mathematica's built-in functions Eigenvalues, Eigenvectors or Eigensystem.  If you just want to know the stability without seeing the numbers, use classify[eqstate].  For two-dimensional systems, you can get more detail by executing classify2D[eqstate].  This tells you the nature of the equilibrium (node, spiral, saddle) as well as the stability.
;[s]
3:0,0;564,1;575,0;913,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = input; preserveAspect]
dermat := Module[{len,ans}, len = Length[statevec];
					ans = Table[Range[len],{len}];
					Do[ans[[i,j]] = 
					D[slopevec[[i]],statevec[[j]]],
						{i,1,len},{j,1,len}];
					ans	]
:[font = input; preserveAspect]
eqstateval[eqstate_] := eqstate /. Thread[parmvec -> parmval]
:[font = input; preserveAspect]
dermatval[eqstate_] := dermat /. Thread[statevec -> 
						eqstateval[eqstate]] /.
						Thread[parmvec -> parmval]
:[font = input; preserveAspect]
rpos[list_] := Module[ {len,ans},len = Length[statevec];
						ans = 0;
						Do[If[(Re[list[[i]]]>0), ans = ans + 1],
						{i,1,len}]; ans]
:[font = input; preserveAspect]
rzero[list_] := Module[ {len,ans},len = Length[statevec];
						ans = 0;
						Do[If[(Re[list[[i]]]==0), 
						    ans = ans + 1],
						{i,1,len}]; ans]
:[font = input; preserveAspect]
classify2D[eqstate_] := Module[{p,q,delt,ans,A,mess,zertst},
					A = dermatval[eqstate];q = Det[A];
					p = A[[1,1]]+A[[2,2]];delt = p*p - 4*q;  
					zertst = (A[[1,1]])^2 + (A[[1,2]])^2
						+ (A[[2,1]])^2 + (A[[2,2]])^2;
mess0 = "Abbreviations used in classify2D.";						
mess1 ="L = linear, NL = nonlinear, R2 = repeated root.";
mess2 = "Z1 = one zero root, Z2 = two zero roots.";
mess3 = "This message printed once."; mess4 = " ";
	ans := "strictly stable - node" /; ((delt>0)&&(p<0)&&(q>0));
	ans := "unstable - node" /; ((delt>0)&&(p>0)&&(q>0));
	ans := "unstable - saddle" /; ((delt>0)&&(q<0));
	ans := "strictly stable - spiral" /; ((delt<0)&&(p<0));
	ans := "unstable - spiral" /; ((delt<0)&&(p>0));
	ans := "unstable - spiral-node transition (R2)" /;
						((delt==0)&&(p>0));
	ans := "strictly stable - spiral-node transition (R2)" /;
						((delt==0)&&(p<0));
	ans := "stable (L), indeterminate (NL) - center"
				/; ((p==0)&&(q>0));
	ans := "unstable - saddle-node transition (Z1)" /;
					((q==0)&&(p>0));
	ans := "stable (L), indeterminate (NL) - saddle-node trans.(Z1)" /;
					((q==0)&&(p<0));
	ans := "unstable (Z2)" /; ((q==0)&&(p==0)&&(zertst>0));
	ans := "stable (L), indeterminate (NL) (Z2)" 
					/; (zertst==0);
     If[(msgflag),(Print[mess0];Print[mess1];Print[mess2];
     				Print[mess3];Print[mess4])];
     msgflag = False;Print[ans]]
:[font = input; preserveAspect]
msgflag = True;
:[font = input; preserveAspect]
classify[eqstate_] := Module[{eiglist,npos,nzero,ans},
				eiglist = Eigenvalues[dermatval[eqstate]];
				npos = rpos[eiglist];
				nzero = rzero[eiglist];
				If[(npos>0),(ans = "unstable"),
					(If[(nzero>0),(ans = 
			"stable (linear) or indeterminate (nonlinear)"),
						(ans = "strictly stable")])];
				Print[ans]]		
:[font = subsubtitle; inactive; preserveAspect; startGroup]
15.  FINDING EQUILIBRIUM POINTS
;[s]
1:0,1;32,-1;
2:0,16,12,Times,2,14,0,0,0;1,19,14,Times,1,18,0,0,0;
:[font = text; inactive; preserveAspect]
     There are three root-finding routines defined here.  The first, findpolyeq, uses Mathematica's Solve to attempt to find analytical expressions for equilibrium points in terms of the parameter symbols.  The second, nfindpolyeq, uses Mathematica's NSolve to find numerical values of equilibrium points, using the current parameter values in parmval.  They both work only for polynomial slope vectors.  With its easier task, nfindpolyeq is more likely to work in a given problem than is findpolyeq.  
;[s]
5:0,0;86,1;97,0;237,1;248,0;503,-1;
2:3,13,10,Courier,0,12,0,0,0;2,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
     For more general systems, the function nfindeq[init], based on the Newton-Raphson technique, works reasonably well with a sufficiently good initial guess init.  If you want to change the minimum number of iterations nmin, the maximum number of iterations nmax, or the relative accuracy criterion eps, just change those parameter values in the defining code below.  To check your answer by evaluating the slopevector at the root, (symbolic or numerical) type residual[root].  If you want a more accurate answer without changing the value of eps, just apply nfindeq to your latest root.  Because the routine iterates at least nmin times, no matter what the residual, the accuracy of your root will increase.  
:[font = input; preserveAspect]
zervec := Table[0, {Length[statevec]}];
:[font = input; preserveAspect]
findpolyeq := statevec /. Solve[slopevec==zervec,statevec]
:[font = input; preserveAspect]
nfindpolyeq := statevec /. NSolve[slopeval==zervec,statevec]
:[font = input; preserveAspect]
nfindeq[init_] := Module[{nmax,nmin,eps,ans,new,old,n,mess},
				mess = "Halt at max iterations.";
				eps = 1.0*10^(-6); nmin = 3; nmax = 12;
				new = init; old = init; n = 0;
				While[(((n<=nmax)&&
				  (sqnorm[new-old]>eps*eps*sqnorm[new]))
				  ||(n<nmin)),
				  (n = n+1; old = new;
				  new = old - Dot[Inverse[dermatval[old]],
				slopeval /. Thread[statevec -> old]])];
				If[(n=nmax),Print[mess]];
				new]    
					
:[font = input; preserveAspect; endGroup; endGroup]
residual[root_] := Simplify[If[(VectorQ[root,NumberQ]),
					(slopeval /. Thread[statevec -> root]),
					(slopevec /. Thread[statevec -> root])]] 


:[font = subtitle; inactive; preserveAspect; startGroup]
16.  INDEX THEORY AND ORBIT TRAPPING
:[font = text; inactive; preserveAspect]
     The details of how to define a curve have been given in the Overview and won't be repeated here.  Once a curve has been defined, we can use it in three ways.  (1) The curve can be plotted by the command plotcurve[mycurve].  (2) We may calculate the index of the curve with respect to the current slope vector by the command index[mycurve].  (3) We may use orbcross[mycurve] to check the direction of the orbits relative to the curve normal.  Orbcross returns a brief report of the situation, and is used mainly to determine whether an orbit is trapped by a given curve.    
:[font = text; inactive; preserveAspect]
     The two routines arclist and curvlist construct lists of points from the curve definition.  The routine arclist does this for a single arc, and curvlist constructs a single list from all the component arcs.  These lists are used in plotting and in the orbit crossing calculations.  The variable ncurpoints (presently set to 100) determines how many points are constructed for each arc.  If you think you may not be resolving small scale oscillations in your particular slopevector, you can try increasing ncurpoints.
:[font = input; preserveAspect]
ncurpoints = 100;
:[font = input; preserveAspect]
arclist[arc_] := Module[
		{ans,runrange,posvec,runner,beg,en,h},
	    ans = Range[ncurpoints+1];
		posvec = First[arc];runrange = Last[arc];
		runner = runrange[[1]]; beg = runrange[[2]];
		en = runrange[[3]]; h = N[(en-beg)/(ncurpoints)]; 
		Do[ans[[i+1]] = posvec /. runner -> beg + h*i,
			{i,0,ncurpoints}];
		ans] 
:[font = input; preserveAspect]
curvlist[curve_] := Module[{ans,len},len = Length[curve];
					ans = arclist[curve[[1]]];
					If[(len > 1),
					(Do[ans = Join[ans,
						Delete[arclist[curve[[i+1]]],1]],
					   {i,1,len-1}])];
					ans]  
:[font = text; inactive; preserveAspect]
     The routine plotcurve[mycurve] plots mycurve in the phase plane, using the graphics settings discussed earlier in connection with phaseplot.  It ignores the setting of pointcon, and always produces a connected line rather than a point plot. 
:[font = input; preserveAspect]
plotcurve[curve_] := (Show[Graphics[{Thickness[lnthick],
						Line[curvlist[curve]]}],Axes -> axon,
						PlotRange -> plrange,
						AxesOrigin -> axorg, 
						AxesLabel -> 
						{statevec[[1]],statevec[[2]]},
						PlotLabel -> plotlab,
						DisplayFunction -> 
					(If[display,$DisplayFunction,Identity]),
						AspectRatio -> asprat])	
 
:[font = text; inactive; preserveAspect]
     Now we define the tangent and normal vectors for the curve.  Of the two possible normals, the one defined here is obtained from the tangent vector by a 90 degree clockwise rotation.  With this definition, the normal to a positively oriented closed curve (conventionally counterclockwise) is the exterior normal. 
:[font = input; preserveAspect]
tanvec[arc_] := D[First[arc],First[Last[arc]]]; 
:[font = input; preserveAspect]
normvec[arc_] := {Last[tanvec[arc]],-First[tanvec[arc]]}
:[font = text; inactive; preserveAspect]
     The code below defines orbcross.  The first routine, orbarcross, does the calculation for a single arc.  Then orbcross combines the results for the component arcs.  A more-or-less self-explanatory verbal report is returned by orbcross. Because of roundoff, we must redefine very small values of the dot product to be zero.  The parameter orbeps is the official zero in this calculation.  Be warned that, because of this zero fuzziness, a reported tangency could in principle be a very slight leak of an orbit in or out.  
:[font = input; preserveAspect]
orbeps = 1.0*10^(-8);
:[font = input; preserveAspect]
orbarcross[arc_] := Module[{runner,tempos,tempnorm,tempslope,
		result,sloval,nval,h,ans,npos,nneg,nzer,beg,en},
		runner = First[Last[arc]];
		beg = arc[[2,2]]; en = arc[[2,3]];
		tempos = First[arc]; tempnorm = normvec[arc];
		tempslope = slopeval /. Thread[statevec -> tempos];
		h = N[(en - beg)/ncurpoints];
		npos = 0; nneg = 0; nzer = 0;
		Do[(sloval = tempslope /. runner -> beg + i*h;
			nval = tempnorm /. runner -> beg + i*h;
			ans = Dot[sloval,nval];
			If[(Abs[ans]<orbeps),(ans = 0)];
			If[(ans > 0),(npos = npos + 1),
				(If[(ans==0),(nzer = nzer+1),
					  (nneg = nneg+1)])]),
					   	{i,0,ncurpoints}];
		result = {npos,nneg,nzer};
		result]
					    
:[font = input; preserveAspect]
orbcross[curve_] := Module[{crossvec,len,incvec},
		len = Length[curve];
		crossvec = orbarcross[curve[[1]]];
		If[(len>1),
			(Do[(incvec = orbarcross[curve[[i]]];
				crossvec = crossvec+incvec;),
					{i,2,len}])];
		If[(crossvec[[3]]>0),(Print[
		"Tangencies:  Yes."]), (Print[
		"Tangencies:  No."])];
		If[(crossvec[[2]]>0), (Print[
		"Crossings in negative N direction:  Yes."]),
		(Print["Crossings in negative N direction:  No."])];
		If[(crossvec[[1]]>0), (Print[
		"Crossings in positive N direction:  Yes."]),
		(Print["Crossings in positive N direction:  No."])]] 		  
				 		    
				
:[font = text; inactive; preserveAspect]
     The final code in this section calculates the index of a curve with respect to the current slope vector.  The routine arcindex[arc] calculates the rotation of the slope vector in radians as arc is traversed.  The routine index[curve] applies arcindex to each arc of the curve, adds the results, divides by 2Pi, and then rounds to the nearest integer.  
:[font = input; preserveAspect]
arcindex[arc_] := Module[{ftemp,gtemp,delf,delg,delrot,rot,
				runner,slopetemp,postemp,
				newg,oldg,newf,oldf,h,beg,en},
				runner = First[Last[arc]];
				postemp = First[arc];
				slopetemp = slopeval /. 
					Thread[statevec -> postemp];
				beg = arc[[2,2]]; en = arc[[2,3]];	
				h = N[(en - beg)/ncurpoints];	
				ftemp = slopetemp[[1]];
				gtemp = slopetemp[[2]];
				fnew = ftemp /. runner -> beg;
				gnew = gtemp /. runner -> beg;
				rot = 0.0;
				Do[(fold = fnew; gold = gnew;
					fnew = ftemp /. runner -> beg + i*h;
					gnew = gtemp /. runner -> beg + i*h;
					delf = fnew - fold; delg = gnew - gold;
					delrot = 
			(fnew*delg - gnew*delf)/(fnew*fnew + gnew*gnew);
					rot = rot + delrot;),
					{i,1,ncurpoints}];
					rot]			
:[font = input; preserveAspect; endGroup]
index[curve_] := Module[{ans,len,roter},len = Length[curve];
					roter = arcindex[curve[[1]]];
					If[(len>1), 
						(Do[(roter = 
							roter + arcindex[curve[[i]]]),
							{i,2,len}])];
					Round[roter/N[2.0*Pi]]]		
					
:[font = subtitle; inactive; preserveAspect; startGroup]
17.  BENDIXSON AND DULAC TESTS
:[font = text; inactive; preserveAspect]
     We begin by defining the divergence in n dimensions.  Given any vector F in the state variables and parameter symbols, we define div[F] as the divergence.  In particular the divergence of the slope vector is div[slopevec].  The divergence with the current parameter values substituted is dival[F].  Thus  dival[slopevec] = div[slopeval].
:[font = text; inactive; preserveAspect]
     For two-dimensional systems, we have Bendixson's test for periodic solutions, which requires the examination of the divergence of the slope vector for sign changes. In Dulac's test, this is generalized to the divergence of a scalar function g times the slope vector, which is calculated as div[g slopevec].  To give a quick picture of the sign changes in this two-dimensional case, we have defined signcontour[v] for any scalar expression v.  This gives a contour plot with areas of positive v being white, negative v being gray.  The plotting window for this is taken as the current value of plrange.
:[font = input; preserveAspect]
div[F_] := Module[{ans,len},ans = 0;len = Length[statevec];
			Do[ans = ans + D[F[[i]],statevec[[i]]],{i,1,len}];
			ans] 
:[font = input; preserveAspect]
dival[F_] := div[F] /. Thread[parmvec -> parmval]
:[font = input; preserveAspect]
clr[0.] = GrayLevel[0.8];
:[font = input; preserveAspect]
clr[1.] = GrayLevel[1.0];
:[font = input; preserveAspect; endGroup]
signcontour[v_] := Module[{x,y,vmod},vmod = v /. 
					Thread[statevec -> {x,y}]; 
					ContourPlot[vmod,{x,
					plrange[[1,1]],plrange[[1,2]]},
					{y,plrange[[2,1]],
					plrange[[2,2]]},Contours -> {0},
					ColorFunction -> clr,
					Axes -> axon, AxesLabel -> 
					{statevec[[1]],statevec[[2]]},
					AxesOrigin -> Automatic,
					DisplayFunction -> 
					(If[display,$DisplayFunction,Identity]),
					PlotLabel -> plotlab, 	
					AspectRatio -> asprat]]	

:[font = subtitle; inactive; preserveAspect; startGroup]
18.  LIAPUNOV FUNCTIONS IN TWO DIMENSIONS
:[font = text; inactive; preserveAspect]
     The function orbdt[V] takes an expression V in the current state variables and time,  and returns the orbital time derivative based on the current slope vector.  Any parameters in the slope function are left as symbols.  The function orbdtval[V] calculates the orbital derivative and replaces the parameters in parmvec with the current values in parmval.  These functions are defined for systems of any dimension.   
:[font = text; inactive; preserveAspect]
     To include parameters in a function V, specify their symbols in the vector liaparmvec and give their values in the vector liaparmval.  
:[font = text; inactive; preserveAspect]
     The function liapsign[V] produces a contour plot in which regions of positive V are white, and regions of negative V are grey.  Before constructing the plot, current values are substituted both for parmvec in the slope, and liapvec in V.  The function liapsignseq[parmlist,V] produces a sequence of such contour plots using the parameter values in parmlist.  
:[font = text; inactive; preserveAspect]
     The function liapcontours[V] produces a full twenty-contour plot of V.  The plotting window for the graphics routines here is taken from the setting of plrange.
:[font = input; preserveAspect]
orbdt[V_] := Module[{len,ans}, len = Length[statevec];
			 ans = 0;
			 Do[ans = ans+(D[V,statevec[[i]]])(slopevec[[i]]),
			 	{i,1,len}];
			 ans + D[V,t]]		
:[font = input; preserveAspect]
orbdtval[V_] := (orbdt[V] /. Thread[parmvec -> parmval]
					/. Thread[liaparmvec -> liaparmval])
:[font = input; preserveAspect]
liaplab := Module[{ans,l1,l2,seq1,seq2,seq3},
			l1 = Length[parmvec]; l2 = Length[liaparmvec];
			seq1 = SequenceForm[parmvec,"=",parmval];
			seq2 = "  ";
			seq3 = SequenceForm[liaparmvec,"=",liaparmval];
			ans := SequenceForm[seq1,seq2,seq3] /;
					((l1>0)&&(l2>0));
			ans := seq1 /; ((l1>0)&&(l2==0));
			ans := seq3 /; ((l1==0)&&(l2>0));
			ans := sysname /; ((l1==0)&&(l2==0));
			ans]		
:[font = input; preserveAspect]
liapsign[V_] := Module[{x,y,vmod},vmod = V /. 
					Thread[statevec -> {x,y}] /.
					Thread[parmvec -> parmval] /.
					Thread[liaparmvec -> liaparmval];
					ContourPlot[vmod,{x,
					plrange[[1,1]],plrange[[1,2]]},
					{y,plrange[[2,1]],
					plrange[[2,2]]},Contours -> {0},
					ColorFunction -> clr,
					Axes -> axon, AxesLabel -> 
					{statevec[[1]],statevec[[2]]},
					AxesOrigin -> Automatic,
					DisplayFunction -> 
					(If[display,$DisplayFunction,Identity]),
					PlotLabel -> liaplab, 	
					AspectRatio -> asprat]]	

:[font = input; preserveAspect]
liapsignseq[parmlist_,V_] := Module[{num},
							 num = Length[parmlist];
							 Print["Liapunov Sequence for ",V];
							 Do[(liaparmval = parmlist[[i]];
							 	liapsign[V]),{i,1,num}]]
							 
:[font = input; preserveAspect; endGroup]
liapcontours[V_] := Module[{x,y,vmod},vmod = V /. 
					Thread[statevec -> {x,y}] /.
					Thread[parmvec -> parmval] /.
					Thread[liaparmvec -> liaparmval];
					ContourPlot[vmod,{x,
					plrange[[1,1]],plrange[[1,2]]},
					{y,plrange[[2,1]],
					plrange[[2,2]]},
					ContourShading -> False,
					Contours -> 20,
					Axes -> axon, AxesLabel -> 
					{statevec[[1]],statevec[[2]]},
					AxesOrigin -> Automatic,
					DisplayFunction -> 
					(If[display,$DisplayFunction,Identity]),
					PlotLabel -> liaplab, 	
					AspectRatio -> asprat]]	

:[font = subtitle; inactive; preserveAspect; startGroup]
19.  POINCARE MAPS FOR DRIVEN SYSTEMS
:[font = text; inactive; preserveAspect]
     We define here a Poincare map for a periodically driven system.  The map is produced in two steps.  The first step is to execute the function drpoincsol, which produces a solution list appropriate for the map.  The second step is drpoincmap which produces the map from the solution list, or drpoincmap3D for a three-dimensional view.  To generate a list of the Poincare points rather than a map, use drpoinclist.  A detailed description of the use of these functions is given in the Overview, so we just give a few remarks on implementation here.  The integration is carried out for poincpointper points per period, where poincpointper must be some multiple of 24 (including 24 itself).  The value of poincpointper is currently set at 48.  The available phases are at 15 degree intervals.     
:[font = text; inactive; preserveAspect]
     In the graphs produced, the default point size is 0.008.  To change that, just assign the value you wish to the variable poincptsize.
:[font = input; preserveAspect]
poincpointper = 48;
:[font = input; preserveAspect]
drpoincsol[initvec_,t0_,tau_,numper_] := Module[
				{h,nsteps,tauint},
				tauint = N[tau /. Thread[parmvec -> parmval]];	
			 	h = tauint/N[poincpointper];
				nsteps = poincpointper*(numper+1);
				integrate[initvec,t0,h,nsteps]]
:[font = input; preserveAspect]
drpoinclist[sol_,cycphase_] := Module[{subsol,elem,skipfac,
					nphase},
					skipfac = poincpointper/24;
					nphase = Round[Mod[cycphase, 360]/15];
					len = Length[sol] - poincpointper;
					subsol = {};
					Do[(elem = sol[[p+skipfac*nphase]];
						subsol = Append[subsol,elem]),
						{p,1,len,poincpointper}];
					subsol]	
:[font = input; preserveAspect]
drpoincmap[sol_,cycphase_,i_,j_] := (CheckAbort[Module[
		{subsol,nphase,len,deg,tempcon,poincgr,
		temppt,tempparmvec,tempparmval},
		len = Length[sol] - poincpointper;
		tempcon = pointcon; temppt = ptsize;
		tempparmvec = parmvec; tempparmval = parmval;
		parmvec = Append[parmvec,HoldForm[phase]];
		ptsize = poincptsize; pointcon = False;
		nphase = Round[Mod[cycphase, 360]/15];
		deg = 15*nphase;
		parmval = Append[parmval,PaddedForm[deg,3]]; 
		poincgr = phaseplot[drpoinclist[sol,cycphase],i,j];
		pointcon = tempcon; ptsize = temppt;
		parmvec = tempparmvec; parmval = tempparmval;
		poincgr],
		(pointcon = tempcon; ptsize = temppt;
		parmvec = tempparmvec;parmval = tempparmval)])
:[font = input; preserveAspect; endGroup]
drpoincmap3D[sol_,cycphase_,i_,j_,k_] := (CheckAbort[Module[
		{subsol,nphase,len,deg,tempcon,poincgr,
		temppt,tempparmvec,tempparmval},
		len = Length[sol] - poincpointper;
		tempcon = pointcon; temppt = ptsize;
		tempparmvec = parmvec; tempparmval = parmval;
		parmvec = Append[parmvec,HoldForm[phase]];
		ptsize = poincptsize; pointcon = False;
		nphase = Round[Mod[cycphase, 360]/15];
		deg = 15*nphase;
		parmval = Append[parmval,PaddedForm[deg,3]]; 
		poincgr = phaseplot3D[drpoinclist[sol,cycphase],i,j,k];
		pointcon = tempcon; ptsize = temppt;
		parmvec = tempparmvec; parmval = tempparmval;
		poincgr],
		(pointcon = tempcon; ptsize = temppt;
		parmvec = tempparmvec;parmval = tempparmval)])
				
				
:[font = subtitle; inactive; preserveAspect; startGroup]
20.  POINCARE MAPS FOR AUTONOMOUS SYSTEMS
:[font = text; inactive; preserveAspect]
     We define here a Poincare map for autonomous systems.  The basic function, poinclist, operates on any previously calculated solution and produces a list of the intersections of the solution with the plane specified by the user.  This plane is specified by poincplane = {a,b}, where a is the normal vector of the plane, and b is the constant in the plane equation a.x + b = 0.  If you wish to distinguish negative from positive crossings, you may apply the functions poincplus or poincminus to the list produced by poinclist.  To plot the Poincare map, you may use any of the previously defined plotting routines.  To make it easier, we have defined poincmap and poincmap3D -- very minor variations of phaseplot and phaseplot3D -- which plot unconnected dots.  (To change the dot size, change the value of the variable poincptsize.)  For three-dimensional systems, the routine poincmapopt3D chooses a viewpoint for the three-dimensional plot aligned along the negative of the normal vector a.  
:[font = input; preserveAspect]
poinclist[sol_] := Module[{norm,con,newside,
			oldside,crosstest, ans,curx,curxt,
			oldxt,terpxt,len,lam},
			len = Length[sol]; ans = {};
			con = Last[poincplane]; 
			norm = Drop[poincplane,-1];  
			curxt = First[sol]; curx = Drop[curxt,1];
			newside = Dot[norm,curx] + con;
			If[(newside==0),
				(ans = Append[ans,curxt])];
			Do[(oldxt = curxt;curxt = sol[[i]];
				curx = Drop[curxt,1];
				oldside = newside;
				newside = Dot[norm,curx] + con;
				crosstest = oldside*newside;
				If[(newside==0),
					(ans = Append[ans,curxt])];
				If[(crosstest<0),
					(lam = (oldside)/(oldside-newside);
					terpxt = oldxt + lam*(curxt-oldxt);
					ans = Append[ans,terpxt])]),
				{i,2,len}];
			ans]			
:[font = input; preserveAspect]
poincminus[sol_] := Module[
			{norm,ans,curx,curxt,len,curslope},
			len = Length[sol]; ans = {};
			norm = Drop[poincplane,-1];
			Do[(curxt = sol[[i]];curx = Drop[curxt,1];
				curslope = slopeval /. Thread[statevec -> curx];
					If[(Dot[curslope,norm]<0),
						(ans=Append[ans,curxt])]),
				{i,1,len}];
			ans]			
:[font = input; preserveAspect]
poincplus[sol_] := Module[
			{norm,ans,curx,curxt,len,curslope},
			len = Length[sol]; ans = {};
			norm = Drop[poincplane,-1];
			Do[(curxt = sol[[i]];curx = Drop[curxt,1];
				curslope = slopeval /. Thread[statevec -> curx];
					If[(Dot[curslope,norm]>0),
						(ans=Append[ans,curxt])]),
				{i,1,len}];
			ans]		
								
:[font = input; preserveAspect]
poincmap[sol_,i_,j_] := Module[{ans},
				tempcon = pointcon;
				temppt = ptsize;
				ptsize = poincptsize;
				pointcon = False;
				ans = phaseplot[sol,i,j];
				pointcon = tempcon;
				ptsize = temppt;
				ans]
		
:[font = input; preserveAspect]
poincmap3D[sol_,i_,j_,k_] := Module[{ans},
				tempcon = pointcon;
				temppt = ptsize;
				ptsize = poincptsize;
				pointcon = False;
				ans = phaseplot3D[sol,i,j,k];
				pointcon = tempcon;
				ptsize = temppt;
				ans]
	
:[font = input; preserveAspect]
poincview := N[Module[{norm,uninorm},norm=Drop[poincplane,-1];
					uninorm = norm/(Sqrt[Dot[norm,norm]]);
					33.84*uninorm]]
					
:[font = input; preserveAspect; endGroup]
poincmapopt3D[sol_] := Module[{ans,tempview},
				tempcon = pointcon;
				temppt = ptsize;
				tempview = viewpt;
				ptsize = poincptsize;
				pointcon = False;
				viewpt = poincview;
				ans = phaser3D[sol];
				pointcon = tempcon;
				ptsize = temppt;
				viewpt = tempview;
				ans]
	
:[font = subtitle; inactive; preserveAspect; startGroup]
APPENDIX A
DESCRIPTIONS OF TUTORIAL NOTEBOOKS
:[font = text; inactive; noPageBreakBelow; preserveAspect]
     There are 12 tutorial notebooks accompanying this package.   Brief descriptions are given below.  In all but the last tutorial, the emphasis is on illustrating the use of the basic functions, and no attempt is made to give a thorough analysis of the particular dynamical systems used.  The first tutorial in particular has detailed explanations, and it is recommended that you start with it.  In the last tutorial, the focus is changed somewhat, and there we look at a number of interesting solutions of the Lorenz equations.      
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL ONE -- INTEGRATION AND PLOTTING (2D)

     This tutorial uses the linear, damped, undriven oscillator as an example.  The focus is on basic integration and plotting in two dimensions.  The functions and variables used in this tutorial are asprat, bothdirflag, buildinterp, dirfield, integrate, intreport, intreset, joinsol, lastx, lastt, lasttx, lnthick, parmreport, parmval, parmvec, phaseplot, phaser, plrange, plotreport, plotreset, pointcon, ptsize, setparm, setstate, show, slopevec, staterange, statevec, stripsol, subsol, sysid, sysname, sysreport, timeplot, and trange.   
;[s]
2:0,0;47,1;590,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; dontNoPageBreakBelow; preserveAspect]
TUTORIAL TWO -- INTEGRATION AND PLOTTING (3D)

     This tutorial uses the Rossler system, a three-dimensional, nonlinear, autonomous system.  The system exhibits a period doubling route to chaos, although only the stable limit cycles are considered in this tutorial.  Most of the 3D plotting routines are illustrated.  The functions and variables used are animate, asprat, boxrat, integrate, inreset, lastt, lastx, parmval, parmvec, period, phaseplot, phaseplot3D, phaser3D, plotreset, rotphaseplot3D, setparm, setstate, slopevec, statevec, sysid, and viewpt.
;[s]
2:0,0;47,1;561,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; noKeepOnOnePage; preserveAspect]
TUTORIAL THREE -- EQUILIBRIUM AND STABILITY

     This tutorial uses two systems as examples.  The first is a linear system of dimension two with a single parameter.  The single equilbrium is at the origin.  The stability is examined for three different values of the parameter.  The second system studied is the Lorenz system.  This system has a pitchfork bifurcation as one of the parameters is varied.  The location and stability of the equilibria are found for several different sets of parameter values.  The functions and variables used are classify, classify2D, dermat, dermatval, findpolyeq, nfindeq, nfindpolyeq, parmval, parmvec, residual, setparm, setstate, slopevec, statevec, and sysid.
;[s]
2:0,0;45,1;700,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL FOUR -- LOCAL SOLUTION NEAR EQUILIBRIUM POINT

     This tutorial uses a nonlinear autonomous system of dimension two as an example.  The system has a single equilibrium at the origin which is a saddle.  The stable and unstable manifolds of the saddle are constructed.  The stable and unstable manifolds of the linearized system are constructed to illustrate the tangency connection at the equilibrium point.  The functions and variables used are axon, classify2D, dermat, dermatval, integrate, parmval, parmvec, phaser, plrange, rangeflag, ranger, restoresys, savesys, setparm, setstate, slopevec, statevec, sysname, and sysid.
;[s]
2:0,0;56,1;638,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect; startGroup]
TUTORIAL FIVE -- COMPARISON OF INTEGRATION METHODS
:[font = text; inactive; preserveAspect; endGroup]
     This tutorial uses the Lorenz equations as an example.  The four methods of integration in the package are used to construct 2000 time steps of a solution in the chaotic regime of parameters.  The four methods are (1) NDSolve without a maximum step size, (2) NDSolve with a maximum step size, (3) fourth order Runge-Kutta without range checking, (4) fourth order Runge-Kutta with range checking.  Each method is timed, and a graph of the results is constructed for each method.  The functions and variables used are asprat, fastflag, integrate, intreset, maxstepflag, parmval, parmvec, phaseplot, plotreset, rangeflag, ranger, setparm, setstate, slopevec, staterange, statevec, sysid, and sysname.  
:[font = subsubsection; inactive; preserveAspect; startGroup]
TUTORIAL SIX -- PERIODIC SOLUTIONS OF AUTONOMOUS SYSTEMS
:[font = text; inactive; preserveAspect; endGroup]
     In this tutorial, we use three different systems to illustrate calculations with periodic solutions.  We use the undamped Duffing equation to illustrate a nonlinear center, the van der Pol equation to illustrate a 2D limit cycle, and the Rossler equations to illustrate a 3D limit cycle.  In addition to calculating and plotting the solutions, we use the function period to find periods, and we construct several Poincare maps.  We also illustrate the use of slope divergence to learn something about the location of periodic solutions (Bendixson test).  The functions and variables used here are asprat, axon, axorg, div, dival, integrate, intreset, joinsol, lastt, lastx, limcyc, parmval, parmvec, period, phaseplot, phaser, phaser3D, plotreset, plrange, poinclist, poincmap, poincmapopt3D, poincmap3D, poincminus, poincplane, poincplus, poincptsize, restoresys, savesys, setparm, setstate, show, signcontour, slopevec, statevec, sysname, sysid, and sysreport.   
;[s]
2:0,1;5,0;971,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL SEVEN -- PERIODIC SOLUTIONS OF DRIVEN SYSTEMS

     We use the damped driven pendulum here to illustrate the routines for periodic solutions of periodically driven systems.  We construct solutions and Poincare maps for several different parameter sets -- some leading to periodic solutions, one leading to a chaotic solution.  The functions and variables used in this tutorial are asprat, display, drpoinclist, drpoincmap, drpoincmap3D, drpoincsol, integrate, intreset, lastt, lastx, modsol, parmval, parmvec, phaser, plotreset, plot, plrange, poincpointper, poincptsize, pointcon, setparm, setstate, show, slopevec, staterange, statevec, sysid, sysname, timeplot, and trange.   
;[s]
3:0,0;56,1;61,2;689,-1;
3:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL EIGHT -- ORBIT TRAPPING AND INDEX THEORY

     This tutorial illustrates the use of routines for index calculations and orbit trapping in two-dimensional systems.  As examples, we use several simple linear and nonlinear systems.  We show how to define curves, how to determine whether a curve traps orbits, and how to find the index of a closed curve with respect to a given system.   The functions and variables used in this tutorial are classify2D, dirfield, display, index, limcyc, orbcross,  parmval, parmvec, period, phaser, plotcurve, plotreset, plrange, setparm, setstate, show, slopevec, statevec, and sysid.   
;[s]
2:0,0;51,1;629,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL NINE -- PHASE PORTRAITS

     In this tutorial, we illustrate the production of phase portraits from a given set of initial conditions.  We also show how to construct a sequence of graphs which, when animated, gives a dynamic view of the orbits in time.  For a two-dimensional example, we use the van der Pol equation.  For a three-dimensional example, we use the van der Pol equation embedded in a three-dimensional system.  The functions and variables used in this tutorial are asprat, boxrat, display, integrate, intreset, limcyc,  parmval, parmvec, period, phaser, phaseseq, phaseseq3D, plotreset, plrange, portrait, portrait3D, restoresys, savesys, setparm, setstate, show, slopevec, statevec, sysid, and sysreport.   
;[s]
3:0,0;34,1;39,2;733,-1;
3:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL TEN -- BIFURCATION SEQUENCES

     In this tutorial, we use the routines bifurc, bifurc3D, limbifurc, and limbifurc3D to construct sequences of phase portraits corresponding to specified sequences of system parameters.  As examples, we use both two- and three-dimensional linear systems depending on a single parameters.  We also use two- and three-dimensional versions of the van der Pol equation.  The graph sequences, when animated, give a dynamic view of the bifurcations.  The functions and variables used in this tutorial are asprat, bifurc, bifurc3D, boxrat, classify, classify2D, intreset, limbifurc, limbifurc3D, parmval, parmvec, plotreset, plrange, rangeflag, ranger, savesys, setparm, setstate, slopevec, statevec, sysid, and sysname.   
;[s]
2:0,0;39,1;759,-1;
2:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect]
TUTORIAL ELEVEN -- LIAPUNOV FUNCTIONS

     In this tutorial, we use Liapunov functions to look at the stability of some planar equilibria.  The routines demonstrated  do not help in the selection of a trial form for a Liapunov function, but they do allow a quick graphical check on the sign of either the function or its orbital derivative.  As examples, we use two simple nonlinear systems for which linearization does not yield a definite answer on the stability question.  The functions and variables used in this tutorial are classify2D, liaparmval, liaparmvec, liapcontours, liapsign, liapsignseq, orbdt, orbdtval, parmval, parmvec, plotreset, plrange, portrait, setparm, setstate, slopevec, statevec, sysid, and sysname.        
;[s]
3:0,0;39,1;44,2;736,-1;
3:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect; endGroup]
TUTORIAL TWELVE -- THE LORENZ EQUATIONS

     In this tutorial, we look at some interesting features of solutions of the Lorenz equations.  The mode is not that of exploration, but rather verification and visualization of some results that are known for these equations.  The three parameters of the Lorenz equations are sigma, r, and b.  Here we take the frequently used values of sigma = 10.0 and b = 8/3, and we look at properties of the solutions for selected values of r.  The functions and variables used in this tutorial are asprat, boxrat, classify, dermatval, dival, eqstateval, fastflag, findpolyeq, integrate, intreset, joinsol, lastt, lastx,  parmval, parmvec, phaseplot, phaser3D, plotreset, plrange, portrait3D, rangeflag, ranger, setparm, setstate, show3D, slopevec, staterange, statevec, sysid, sysname, and timeplot.     
;[s]
3:0,0;41,1;46,2;839,-1;
3:1,13,9,Times,1,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,0,12,0,0,0;
:[font = subtitle; inactive; pageBreak; preserveAspect; startGroup]
APPENDIX B
INDEX OF PRINCIPAL ROUTINES
:[font = text; inactive; preserveAspect]
     In this section, we give an alphabetical listing of all the principal user objects (variables and functions) in this package, along with a very brief description.  This is intended as a quick reference, and it does not replace the more detailed descriptions in the Overview (Section 2 of this document).  For each object, we give the section of this document in which the Mathematica code is specified, and a list of the tutorials in which the object is used.       
;[s]
3:0,0;377,1;388,0;472,-1;
2:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
animate[sol,i,j,k,ng] -- Constructs from components i,j, and k of the solution sol a rotation sequence of three-dimensional phase plots, suitable for animation.  The number of graphs in the sequence is ng, with the increment of rotation about the z-axis being 360/ng degrees.  Section 9.  Tutorial 2.
;[s]
2:0,1;7,0;301,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
asprat -- Variable controlling aspect ratio of two-dimensional plots.  Can be set to a number (ratio of vertical to horizontal) or to Automatic.  Default is Automatic.  Section 8.  Tutorials 1, 2, 5, 6, 7, 9, 10, and 12.  
;[s]
2:0,1;6,0;223,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
axon -- Logical variable controlling the appearance of axes in plots.  True for axes, False for no axes.  The default is True.  Section 8.  Tutorials 4 and 6.
;[s]
2:0,1;4,0;159,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
axorg -- Variable controlling axes origin in two-dimensional plots.  Can be set to a list of two values, or to Automatic, which is the default.  Section 8.  Tutorial 6. 
;[s]
2:0,1;5,0;170,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
bifurc[intlist,t0,h,nsteps,i,j,parmlist] -- Produces a sequence of two-dimensional phase plots of components i and j.  For each plot, orbits are constructed for each set of initial conditions in the list intlist.  The integrations are carried out with time step h and number of steps nsteps.  The argument t0 can be either a single number (initial time) or a list of initial times to be used in sequence with intlist.  A plot is constructed for each set of values of parmval in parmlist.  Section 11.  Tutorial 10.   
;[s]
2:0,1;6,0;518,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
bifurc3D[intlist,t0,h,nsteps,i,j,parmlist] -- Produces a sequence of three-dimensional phase plots of components i,j and k.  For each plot, orbits are constructed for each set of initial conditions in the list intlist.  The integrations are carried out with time step h and number of steps nsteps.  The argument t0 can be either a single number (initial time) or a list of initial times to be used in sequence with intlist.  A plot is constructed for each set of values of parmval in parmlist.  Section 11.  Tutorial 10.   
;[s]
2:0,1;8,0;524,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
bothdirflag -- Logical variable controlling direction of integration.  When True, integration is carried out in both time directions from the initial time.  Default is False.  Section 6.  Tutorial 1.
;[s]
2:0,1;11,0;200,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
boxrat -- Variable controlling the aspect ratios of the enclosing box in three-dimensional plots.  Can be a list of three values (giving relative sizes of three box dimensions) or can be set to Automatic.  Default is Automatic.  Section 8.  Tutorials 2, 9, 10, and 12.
;[s]
2:0,1;6,0;269,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
buildinterp[sol] -- Builds from the solution sol an interpolating function for the state vector as a function of time.  Section 13.  Tutorial 1.  
;[s]
2:0,1;11,0;147,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
classify[eqstate] -- Classify the equilibrium point eqstate with respect to stability.  The argument eqstate may contain parameter symbols, which are then evaluated from parmval.  Section 14.  Tutorials 3, 10, and 12. 
;[s]
2:0,1;8,0;219,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
classify2D[eqstate] -- Classify the equilibrium point eqstate of a two-dimensional system.  This gives more information than classify (i.e., node, saddle, spiral, etc.).  Section 14.  Tutorials 3, 4, 8, 10, and 11.
;[s]
2:0,1;10,0;215,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
dermat -- The derivative matrix of the slope vector with respect to the state variables.  State variables, parameters and time all appear as symbols.  Section 14.  Tutorials 3 and 4. 
;[s]
2:0,1;6,0;184,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
dermatval[eqstate] -- The result of evaluating the derivative matrix at the point eqstate, after substituting current parameter values from parmval.  The argument eqstate may contain parameter symbols.  For autonomous systems, the result will be numerical.  For non-autonomous systems, the symbol t will in general appear in dermatval.  Section 14.  Tutorials 3, 4, and 12. 
;[s]
2:0,1;9,0;375,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
dirfield -- Produces a two-dimensional direction field plot from the current statevec and slopevec.  The plotting window is taken to be plrange, which must be set to a numerical range for this application.  Section 10.  Tutorials 1 and 8.
;[s]
2:0,1;8,0;239,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
display -- Logical variable for graph display.  When display is True, graphics object constructed is plotted.  When display is False, object is constructed but not plotted.  The default is True.  Section 8.  Tutorials 7, 8, and 9.  
;[s]
2:0,1;7,0;233,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
div[vec] -- Returns the divergence of the vector vec with respect to the state vector.  Section 17.  Tutorial 6.
;[s]
2:0,1;3,0;113,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
dival[vec] -- Returns the divergence of the vector vec with respect to the state vector, and with parmvec replaced by the current values in parmval.  Section 17.  Tutorials 6 and 12.
;[s]
2:0,1;5,0;183,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
drpoincsol[init,t0,tau,numper] -- Produces a solution suitable for a Poincare map in a periodically driven system.  The initial value is init, the initial time is t0, the sampling interval (normally the period of the driver) is tau, and the number of periods to be produced is numper.  Section 19.  Tutorial 7. 
;[s]
2:0,1;10,0;312,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
drpoincmap[sol,cycphase,i,j] -- Operates on a solution sol which has been produced by drpoincsol.  Produces a Poincare map with components i and j, and at a phase cycphase.  Cycphase is specified in degrees, and may be any of the 24 values 0(15)345.  Section 19.  Tutorial 7. 
;[s]
2:0,1;10,0;277,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
drpoincmap3d[sol,cycphase,i,j,k] -- Operates on a solution sol which has been produced by drpoincsol.  Produces a Poincare map with components i, j and k, and at a phase cycphase.  Cycphase is specified in degrees, and may be any of the 24 values 0(15)345.  Section 19.  Tutorial 7.
;[s]
2:0,1;12,0;283,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
drpoinclist[sol,cycphase] -- Operates on a solution sol which has been produced by drpoincsol.  Produces a list of all the points in the Poincare map for the phase cycphase.  Section 19.  Tutorial 7.
;[s]
2:0,1;11,0;200,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
fastflag -- Controls integration method.  When True, NDSolve is used.  When False, fourth order Runge-Kutta is used.  Default is False.  Section 6.  Tutorials 5 and 12. 
;[s]
2:0,1;8,0;170,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
eqstateval[state] -- Evaluate the vector state by replacing all parmvec symbols by values from current parmval.  Useful when state is an equilibrium point with coordinates expressed in terms of the symbols of parmvec.  Section 14.  Tutorial 12. 
;[s]
2:0,1;10,0;246,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
findpolyeq -- Find symbolic expressions for equilibrium points for polynomial slope functions.  Section 15.  Tutorials 3 and 12. 
;[s]
2:0,1;10,0;130,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
index[curv] -- Returns the index of the slope vector field with respect to the previously defined curve named curv.  Section 16.  Tutorial 8. 
;[s]
2:0,1;5,0;143,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
integrate[initvec,t0,h,nsteps] -- Integration routine which produces a solution list using initvec for the initial condition, t0 for the initial time, h for the time step, and nsteps for the number of time steps.  If h is negative, the integration proceeds backward in time.  Section 6.  Tutorials 1, 2, 4, 5, 6, 7, 9, and 12. 
;[s]
2:0,1;9,0;328,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
intreport -- Gives a brief report on most recent values of integration.  Section 3.  Tutorial 1. 
;[s]
2:0,1;9,0;98,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
intreset -- Reset the four integration flags to default values:  fastflag = False; maxstepsize = False; rangeflag = False; bothdirflag = False.  Section 6.  Tutorials 1, 2, 5, 6, 7, 9, 10, and 12. 
;[s]
2:0,1;8,0;198,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
joinsol[sol1,sol2] -- Joins into a single solution two contiguous solutions sol1 and sol2.  The last point of sol1 must be the same as the first point of sol2.  Section 7.  Tutorials 1, 6, and 12.
;[s]
2:0,1;7,0;197,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
lastt -- Time coordinate in the last point calculated in the most recent integration.  Section 6.  Tutorials 1, 2, 6, 7, and 12. 
;[s]
2:0,1;5,0;130,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
lasttx -- Last values of time and state vector calculated in the most recent integration.  Section 6.  Tutorial 1.
;[s]
2:0,1;6,0;115,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
lastx -- Last value of state vector calculated in the most recent integration.  Section 6.  Tutorials 1, 2, 6, 7, and 12.
;[s]
2:0,1;5,0;122,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
liaparmval -- Variable containing the current values of the parameters in liaparmvec.  Section 18.  Tutorial 11.
;[s]
2:0,1;10,0;113,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
liaparmvec -- Variable containing the names of the parameters in a Liapunov function.  Section 18.  Tutorial 11.
;[s]
2:0,1;10,0;113,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
liapcontours[v] -- Produces a full 20-contour plot of v.  For two dimensions only.  Takes plot range from plrange.  Section 18.  Tutorial 11. 
;[s]
2:0,1;12,0;143,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
liapsign[v] -- Produces a plot in which regions of positive v are white and regions of negative v are grey.  Current values for parmvec and liaparmvec are taken from parmval and liaparmval before constructing the plot.  Takes plot range from plrange.  Section 18.  Tutorial 11. 
;[s]
2:0,1;8,0;279,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
liapsignseq[parmlist,v] -- Produces a sequence of contour plots.  In each plot, regions of positive v are white and regions of negative v are grey.  A plot is produced for each value of liaparmval in the list parmlist.  Section 18.  Tutorial 11. 
;[s]
2:0,1;11,0;247,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
limbifurc[initvec,t0,h,nsteps,i,j,parmlist] -- Produces a sequence of two-dimensional phase plots (components i and j) of pure limit cycles.  A plot is constructed for each value of parmvec in the list parmlist.  Section 12.  Tutorial 10.   
;[s]
2:0,1;9,0;242,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
limbifurc3D[initvec,t0,h,nsteps,i,j,k,parmlist] -- Produces a sequence of three-dimensional phase plots (components i, j, and k) of pure limit cycles.  A plot is constructed for each value of parmvec in the list parmlist.  Section 12.  Tutorial 10.
;[s]
2:0,1;11,0;249,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
limcyc[intvec,t0,h,nsteps] -- The purpose of this function is to produce a pure limit cycle without any startup transients.  It integrates nsteps starting at intvec, and then uses the last point of this integration as an initial condition for a new integration.  Only the second integration is saved.  Section 12.  Tutorials 6, 8, and 9. 
;[s]
2:0,1;6,0;339,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
lnthick -- Variable controlling the thickness of lines in plots.  Thickness is given relative to plot size.  The default is 0.002.  Section 8.  Tutorial 1.
;[s]
2:0,1;7,0;156,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
maxstepflag -- Only relevant when fastflag is True.  When True, the NDSolve integration takes the specified step size as a maximum step size.  Default is False.  Section 6.  Tutorial 5.
;[s]
2:0,1;11,0;186,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
modsol[sol,k,a,b] -- Replaces the kth component of the solution sol by its value modulo the interval [a,b).  Section 7.  Tutorial 7. 
;[s]
2:0,1;6,0;134,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
nfindeq[init] -- Find numerical values for an equilibrium point using init as a starting guess.  Apply a second time to the result of the first application to refine the root.  Section 15.  Tutorial 3. 
;[s]
2:0,1;7,0;203,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
nfindpolyeq -- Find numerical expressions for equilibrium points for polynomial slope vectors, using values in parmval for parmvec.  Section 15.  Tutorial 3. 
;[s]
2:0,1;11,0;159,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
orbcross[curv] -- Scans a previously defined curve named curv to determine whether curv traps orbits.  The output of orbcross is a brief report on crossing directions.  Section 16.  Tutorial 8.
;[s]
2:0,1;8,0;194,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
orbdt[v] -- Gives the orbital derivative of any function v of the state variables and time.  Section 18.  Tutorial 11.
;[s]
2:0,1;5,0;119,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
orbdtval[v] -- Gives the orbital derivative of v with parameter symbols replaced by current values in parmval and Liapunov parameter symbols in liaparmvec replace by current values in liaparmval.  Section 18.  Tutorial 11.
;[s]
2:0,1;8,0;223,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
parmreport -- Causes a list of system parameters to be displayed on the screen.  Equivalent to executing intreport, plotreport, and sysreport.  Section 2.  Tutorial 1.
;[s]
2:0,1;10,0;168,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
parmval -- The vector giving current numerical values of parmvec.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12. 
;[s]
2:0,1;7,0;121,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
parmvec -- The vector giving the names of the system parameters.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12. 
;[s]
2:0,1;7,0;120,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
period[sol] -- Returns the period of the periodic motion sol.  Section 12.  Tutorials 2, 6, 8, and 9. 
;[s]
2:0,1;6,0;103,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaseplot[sol,i,j] -- Produces a phaseplot of ith component (horizontal) of the solution sol versus jth component (vertical).  Section 9.  Tutorials 1, 2, 5, 6, and 12.
;[s]
2:0,1;9,0;169,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaseplot3D[sol,i,j,k] -- Produces a three-dimensional phase plot of ith, jth, and kth components of solution sol.  Section 9.  Tutorial 2.  
;[s]
2:0,1;11,0;142,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaser[sol] -- Equivalent to phaseplot with i = 1, j = 2.  Section 9.  Tutorials 1, 4, 6, 7, 8, and 9.
;[s]
2:0,1;6,0;103,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaser3D[sol] -- Equivalent to phaseplot3D with i = 1, j = 2, k = 3.  Section 9.  Tutorials 2, 6, and 12.
;[s]
2:0,1;8,0;106,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaseseq[intlist,t0,h,nstepic,npics,i,j] -- Produces a sequence of two-dimensional phase plots (with components i and j) suitable for animation.  Each plot contains orbits for each set of initial conditions in intlist, with time step h.  The plots form a sequence in time, with the time increment between plots being h*nstepic.  The total number of plots is npics.  When the sequence is animated, it gives a simulation of the integral curves being constructed in time.  Section 11.  Tutorial 9.    
;[s]
2:0,1;8,0;499,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
phaseseq3D[intlist,t0,h,nstepic,npics,i,j,k] -- Produces a sequence of three-dimensional phase plots (with components i,j and k) suitable for animation.  Each plot contains orbits for each set of initial conditions in intlist, with time step h.  The plots form a sequence in time, with the time increment between plots being h*nstepic.  The total number of plots is npics.  When the sequence is animated, it gives a simulation of the integral curves being constructed in time.  Section 11.  Tutorial 9.    
;[s]
2:0,1;10,0;507,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
plot[f[t],{t,tmin,tmax}] -- A variation of Mathematica's Plot.  The arguments are f[t], a previously defined function, and the list {t,tmin,tmax} which gives the independent variable and the range for the plot.  It uses current settings of asprat, axon, axorg, display, and plrange.  Section 9.  Tutorial 7.
;[s]
4:0,1;4,0;43,2;54,0;308,-1;
3:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
plotcurve[curv] -- Generates a plot of the previously defined curve named curv.  Section 16.  Tutorial 8. 
;[s]
2:0,1;9,0;107,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
plotreport --  Gives a brief report on the most recent settings of the plotting parameters.  Section 3.  Tutorial 1. 
;[s]
2:0,1;10,0;118,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
plotreset -- Resets all of the plotting control variables to their defaults.  Variables reset are asprat, axon, boxrat, display, lnthick, plrange, poincptsize, pointcon, ptsize, and viewpt.  Section 8.  Tutorials 1, 2, 5, 6, 7, 8, 9, 10, 11, and 12.
;[s]
2:0,1;9,0;250,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
plrange -- Variable controlling the window for plots.  May be set to Automatic, All, or to a numerical range for either two- or three-dimensional plots.  Automatic plots all points except outliers, All plots all points.  The default is All.  Section 8.  Tutorials 1, 4, 6, 7, 8, 9, 10, 11, and 12. 
;[s]
2:0,1;7,0;299,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poinclist[sol] -- Produces a list of the time and space coordinates of all the crossings of the Poincare plane in the solution sol for an autonomous system. Sol may be any solution produced by integrate.  Section 20.  Tutorial 6.  
;[s]
2:0,1;9,0;232,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincmap[sol,i,j] -- The argument sol is a solution list produced by poinclist, or by poincminus or poincplus.  Then poincmap returns the Poincare map of the components i and j.  Section 20.  Tutorial 6. 
;[s]
2:0,1;8,0;205,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincmapopt3D[sol] -- For three-dimensional systems only.  The argument sol is a solution list produced by poinclist, or by poincminus or poincplus.  Then poincmapopt3D returns the three-dimensional view of the Poincare map, with the view point being chosen in the direction -a, where a is the normal to the Poincare plane.  Section 20.  Tutorial 6.  
;[s]
2:0,1;13,0;352,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincmap3D[sol,i,j,k] -- The argument sol is a solution list produced by poinclist, or by poincminus or poincplus.  Then poincmap returns a three-dimensional view of the Poincare map of the components i, j and k.  Section 20.  Tutorial 6. 
;[s]
2:0,1;10,0;240,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincminus[sol] -- The argument sol is a solution list produced by poinclist.  Then poincminus returns the subset of sol corresponding to negative crossings (in the direction of the negative of the normal to the Poincare plane).  Section 20.  Tutorial 6. 
;[s]
2:0,1;10,0;256,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincplane -- Variable containing the parameters defining a Poincare plane for maps in autonomous systems.  It has the form {a,b} where a stands for the n components of the normal vector of the Poincare plane, and b is the constant defining the plane.  The plane is given by   a.x + b = 0.  Section 20.  Tutorial 6. 
;[s]
2:0,1;10,0;317,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincplus[sol] -- The argument sol is a solution list produced by poinclist.  Then poincplus returns the subset of sol corresponding to positive crossings (in the direction of the normal to the Poincare plane).  Section 20.  Tutorial 6. 
;[s]
2:0,1;9,0;238,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincpointper -- A variable defining the number of integration points per period for a Poincare map in a driven system.  It must be a multiple of 24.  The default is 48.  Section 19.  Tutorial 7. 
;[s]
2:0,1;13,0;197,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
poincptsize -- Variable controlling the size of points plotted in Poincare maps.  The size is given relative to the size of the plot.  The default is 0.008.  Section 8.  Tutorials 6 and 7.
;[s]
2:0,1;11,0;189,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
pointcon -- Logical variable controlling connection of points in graphs.  When True, points are connected in a smooth line.  When False, points are plotted with no connecting line.  Default is True.  Section 8.  Tutorials 1 and 7.
;[s]
2:0,1;8,0;231,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
portrait[intlist,t0,h,nsteps,i,j] -- Constructs a two-dimensional phase plot with components i and j.  For each set of initial conditions in the list intlist, an orbit is constructed with time step h and number of steps nsteps.  The initial time t0 may be either a number to be used for all integrations, or a list of initial times to be used in sequence with the entries of intlist.  Section 11.  Tutorials 9 and 11.
;[s]
2:0,1;8,0;418,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
portrait3D[intlist,t0,h,nsteps,i,j] -- Constructs a three-dimensional phase plot with components i, j and k.  For each set of initial conditions in intlist, an orbit is constructed with time step h and number of steps nsteps.  The initial time t0 may be either a number to be used for all integrations, or a list of initial times to be used in sequence with the entries of intlist.  Section 11.  Tutorials 9 and 12. 
;[s]
2:0,1;10,0;417,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
ptsize -- Variable controlling the size of points plotted.  The size is given relative to the plot size.  Default is 0.005.  Section 8.  Tutorial 1.
;[s]
2:0,1;6,0;149,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
rangeflag -- Logical variable controlling range checking.  When True, integration stops whenever system state leaves box specified in ranger.  Only works when fastflag is False.  Default is False.  Section 6.  Tutorials 4, 5, 10, and 12.
;[s]
2:0,1;9,0;238,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
ranger -- Variable containing the range to be used for range checking during integration.  Section 4.  Tutorials 4, 5, 10, and 12.
;[s]
2:0,1;6,0;131,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
residual[root] -- Evaluates the slope vector at the point root.  The argument root may contain parameter symbols.  Section 15.  Tutorial 3. 
;[s]
2:0,1;8,0;141,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
restoresys[nme] -- Replace statevec, slopevec, parmvec, parmval, and sysname by values previously stored under name nme by a savesys command.  Section 2.  Tutorials 4, 6, and 9.  
;[s]
2:0,1;10,0;180,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
rotphaseplot3D[sol,i,j,k,theta] -- Produces a three-dimensional phase plot of components i,j,k of solution sol, rotated by theta degrees about the z-axis.  (The zero angle of rotation is defined by the setting of the variable viewpt.)  Section 9.  Tutorial 2. 
;[s]
2:0,1;14,0;261,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
savesys[nme] -- Save current values of statevec, slopevec, parmvec, and parmval under the name nme.  Save nme under sysname.  System may be recalled with restoresys[nme].  Section 2.  Tutorials 4, 6, 9, and 10.
;[s]
2:0,1;7,0;211,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
setparm[vec] -- Does three things:  (1) clears each of the symbols in vec, (2) assigns the list vec to parmvec, and (3) protects each symbol in vec.  Section 2.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12. 
;[s]
2:0,1;7,0;216,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
setstate[vec] -- Does four things: (1) clears each of the symbols in vec, (2) assigns the list vec to statevec, (3) protects each of the symbols in vec, and (4) clears sysname.  Section 2.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12.   
;[s]
2:0,1;8,0;246,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
show[graphlist] -- A variation of Mathematica's Show.  The argument graphlist is a list of graphics objects.  This command shows them all, regardless of whether display was True or False when they were created.  It uses current settings of asprat, axon, axorg, and plrange.  Section 9.  Tutorials 1, 6, 7, 8, and 9.
;[s]
4:0,1;4,0;34,2;45,0;316,-1;
3:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = text; inactive; preserveAspect]
show3D[graphlist] -- The argument graphlist is a list of 3D graphics obects.  This command shows them all, regardless of whether display was True or False when they were created.  It uses current settings of axon, boxrat, viewpt and plrange.  Section 9.  Tutorial 12. 
;[s]
2:0,1;6,0;269,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
signcontour[v] -- For any scalar function v of the state variables this shows a plot in which the region of positive values of v is white, negative grey.  Works only for two-dimensional systems.  Takes plot range from plrange.  Section 17.  Tutorial 6. 
;[s]
2:0,1;11,0;254,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
slopevec -- User specified vector containing the slope vector in terms of the state vector and system parameters.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12. 
;[s]
2:0,1;8,0;169,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
staterange[sol] -- Returns the minimimum and maximum values in solution sol for each component of the state vector, and the time at which these occur.  Section 7.  Tutorials 1, 5, 7, and 12.
;[s]
2:0,1;10,0;191,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
statevec -- User specified vector containing the names of the components of the state vector.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12.
;[s]
2:0,1;8,0;148,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
stripsol[sol,n] -- Removes the nth component of the state vector from solution sol.  Section 7.  Tutorial 1.
;[s]
2:0,1;8,0;109,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
subsol[sol,rng] -- Returns the subset of solution sol for which the time is in the range specifed by rng.  The form of rng is {tmin,tmax}.  Section 7.  Tutorial 1. 
;[s]
2:0,1;6,0;165,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
sysid -- Causes version numbers to be printed for Mathematica and this package, and the current date.  Section 2.  Tutorials 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, and 12.
;[s]
4:0,2;5,0;50,1;61,0;168,-1;
3:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
sysname -- Variable containing the optional name of the system.  Default is blank.  Sysname is cleared by setstate, so sysname assignment must come after setstate.  Section 2.  Tutorials 1, 7, 10, and 11.
;[s]
2:0,1;7,0;205,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
sysreport -- Gives a brief report of the most recent settings of the system variables (statevec,slopevec,parmvec,parmval and sysname).  Section 2.  Tutorials 1, 6, and 9.
;[s]
2:0,1;9,0;171,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
t -- Reserved name for independent variable.  It is used explicitly only in non-autonomous systems.  Section 2.  Tutorial 7.  
;[s]
2:0,1;1,0;127,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
timeplot[sol,i] -- Produces a plot of the ith component of solution sol versus time.  Section 9.  Tutorials 1, 7, and 12.
;[s]
2:0,1;8,0;122,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
trange[sol] -- Returns a list {tmin,tmax}, where tmin is the minimum time occuring in solution sol, tmax the maximum.  Section 7.  Tutorials 1 and 7.
;[s]
2:0,1;6,0;150,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
viewpt -- Variable controlling viewpoint for three-dimensional plots.  A list of three numbers giving vector direction of viewpoint and distance of viewpoint.  Default is {13,-24,20}. Section 8.  Tutorial 2.
;[s]
2:0,1;6,0;208,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
On[General::spell1];
:[font = input; preserveAspect; endGroup; endGroup]
On[General::spell];
^*)
