(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = subtitle; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS
TUTORIAL 1
:[font = subtitle; inactive; preserveAspect]
Integration and Plotting (2D)

:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, bothdirflag, buildinterp, dirfield, integrate, intreport, intreset, joinsol, lastx, lastt, lasttx, lnthick, parmreport, parmval, parmvec, phaseplot, phaser, plrange, plotreport, plotreset, pointcon, ptsize, setparm, setstate, show, slopevec, staterange, statevec, stripsol, subsol, sysid, sysname, sysreport, timeplot, trange.  
;[s]
2:0,1;47,0;389,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of System Used in This Tutorial

     We use the damped, linear, undriven oscillator to illustrate the basics about defining systems, and constructing and plotting solutions.
;[s]
2:0,1;45,0;187,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We denote the position by x and the velocity (x-dot) by y.  We use a dimensionless formulation in which the undamped frequency is unity, and the dimensionless damping constant is 2 eps.  To define the system, we must specify statevec, slopevec, and parmvec. 
;[s]
2:0,1;19,0;283,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{eps}];
:[font = input; preserveAspect]
slopevec = {y,-x -2*eps*y};
:[font = input; preserveAspect]
slopevec = {y,-x -2*eps*y};
:[font = text; inactive; preserveAspect]
     We choose a moderately damped system by setting eps = 0.2.  We do this not by assigning eps a value, but by assigning the vector parmval a value.  
:[font = input; preserveAspect]
parmval = {0.2};
:[font = text; inactive; preserveAspect]
In fact, the state variables x and y and the parameter eps were protected when the routines setstate and setparm were executed.  Thus we will fail if we attempt the inappropriate command of directly assigning eps a=(or x and y) a value. 
:[font = input; preserveAspect]
eps = 0.3;
:[font = text; inactive; preserveAspect]
We check our definition with sysreport.
:[font = input; preserveAspect]
sysreport
:[font = text; inactive; preserveAspect]
Integration Parameters

     We will be ready to do our first integration as soon as we have chosen an initial state, an initial time, a time step, and the number of time steps  These four quantities appear as arguments of integrate, and they may have any name.  
;[s]
2:0,1;24,0;264,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
initvec = {1.0,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 200;
:[font = text; inactive; preserveAspect]
Integration

     We have a choice of methods of integration.  In this tutorial, we will use the default, which is the fourth order Runge-Kutta with a uniform time step, and with no range checking.  In other tutorials we will look at some of the other options.  We use the command intreset to set the default values for integration. Then we invoke integrate to find the solution, and we name our first solution sol1.
;[s]
2:0,1;13,0;417,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
sol1 = integrate[initvec,t0,h,nsteps];
:[font = text; inactive; preserveAspect]
     Let's see what this solution actually looks like by examining the first five elements.
:[font = input; preserveAspect]
Take[sol1,5]
:[font = text; inactive; preserveAspect]
The solution is a list of lists.  Each element in the list has t, x and y values in that order.  If for any purpose we need to remove one of the coordinates from the list, we can do that with the function stripsol.  For this purpose, the time coordinate is numbered 0 and x and y are 1 and 2 respectively.  As an example, we remove the time coordinate and look at the first five elements of the modified list.
:[font = input; preserveAspect]
notimesol1 = stripsol[sol1,0];
:[font = input; preserveAspect]
Take[notimesol1,5]
:[font = text; inactive; preserveAspect]
     If we have an application which requires a solution in the form of a smooth function rather than a list, we can use the function buildinterp to produce a smooth function from our list.  We do that here for sol1.  We calculate a few sample values.  We will graph this interpolated solution later.
:[font = input; preserveAspect]
{X,Y} = buildinterp[sol1];
:[font = input; preserveAspect]
X[0]
:[font = input; preserveAspect]
Y[0]
:[font = input; preserveAspect]
X[0.2]
:[font = input; preserveAspect]
Y[0.2]
:[font = text; inactive; preserveAspect]
Time Plots

     To see what the solution really looks like, we need to plot it. We first do some time plots.  We reset the plotting parameters to their default values by executing plotreset, and then we set the aspect ratio to 0.5, which is generally a good choice for time plots.
;[s]
2:0,1;12,0;282,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 0.5;
:[font = text; inactive; preserveAspect]
     Now we ask for a plot of x (component 1 of statevec) versus t, then a plot of y (component 2 of statevec) versus t, and then a plot of both versus t.  We name each graph in case we want to use them later. 
:[font = input; preserveAspect]
graph1 = timeplot[sol1,1];
:[font = input; preserveAspect]
graph2 = timeplot[sol1,2];
:[font = input; preserveAspect]
graph3 = timeplot[sol1,{1,2}];
:[font = text; inactive; preserveAspect]
     Notice that each graph is scaled slightly differently.  That's because we are using the default of All for plrange, the variable that controls the plotting window.  We may set our own window.  
:[font = input; preserveAspect]
plrange = {{0,10}, {-1,1}};
:[font = input; preserveAspect]
graph4 = timeplot[sol1,{1,2}];
:[font = text; inactive; preserveAspect]
Phase Plot

     We can also get a phase plane plot of our solution.  We first reset plrange and asprat, and then construct the plot with the function phaseplot.
;[s]
2:0,1;12,0;162,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-1,1},{-1,1}};
:[font = input; preserveAspect]
graph5 = phaseplot[sol1,1,2];
:[font = text; inactive; preserveAspect]
     Let's graph our interpolated solution and compare it with the above graph.  
:[font = input; preserveAspect]
graph5interp = ParametricPlot[{X[t],Y[t]}, {t,0.0,10.0},
				PlotRange -> plrange, AspectRatio -> asprat];
:[font = text; inactive; preserveAspect]
     Now we compare this with graph5 by showing them on the same graph.
:[font = input; preserveAspect]
show[graph5,graph5interp];
:[font = text; inactive; preserveAspect]
     It is often of interest to compare a solution or solutions with the direction field.  We can generate a direction field plot with the command dirfield.  The plotting window for dirfield is always taken from plrange.
:[font = input; preserveAspect]
dirfield;
:[font = text; inactive; preserveAspect]
Continuation of Integration

     Let's continue the integration which produced sol1.  This is made easy by the quantities lastt and lastx (or the combination lasttx) which give the last point calculated.  We look at these quantities first before we use them.
;[s]
2:0,1;29,0;260,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
lasttx
:[font = input; preserveAspect]
lastt
:[font = input; preserveAspect]
lastx
:[font = text; inactive; preserveAspect]
     Now we continue the integration, using the same number of time steps and the same spacing.
:[font = input; preserveAspect]
moresol1 = integrate[lastx,lastt,h,nsteps];
:[font = text; inactive; preserveAspect]
     We plot this piece of the solution and then show it with the previous piece.
:[font = input; preserveAspect]
graph5plus = phaseplot[moresol1,1,2];
:[font = input; preserveAspect]
show[graph5,graph5plus];
:[font = text; inactive; preserveAspect]
     Alternatively, we can combine the solutions first, using joinsol, and then plot the combination.
:[font = input; preserveAspect]
bigsol1 = joinsol[sol1,moresol1];
:[font = input; preserveAspect]
bigraph5 = phaseplot[bigsol1,1,2];
:[font = text; inactive; preserveAspect]
Integrating Backwards in Time

     Now suppose we want to start at the original initial point and go backward in time.  We do that with a negative value of the time step.  We also generate the phase plot with a shortcut command, namely phaser.  This is the same as phaseplot, but with indices i = 1 and j = 2 automatically.  It simply saves a little typing.
;[s]
2:0,1;31,0;359,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
h = -0.05;
:[font = input; preserveAspect]
sol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plrange = {{-2,2},{-2,2}};
:[font = input; preserveAspect]
graph6 = phaser[sol2];
:[font = text; inactive; preserveAspect]
     We can combine these two solutions as before -- either pictorially with a show command, or by using joinsol to combine the solutions before plotting.
:[font = input; preserveAspect]
graph7 = show[graph5,graph6];
:[font = input; preserveAspect]
sol3 = joinsol[sol1,sol2];
:[font = input; preserveAspect]
graph8 = phaser[sol3];
:[font = text; inactive; preserveAspect]
Range of Solution

     It looks like the backward-time part of the solution may extend beyond the range of the graph.  We can easily check the time range with trange and the range of the state vector with staterange.
;[s]
2:0,1;19,0;218,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
trange[sol3]
:[font = input; preserveAspect]
staterange[sol3]
:[font = text; inactive; preserveAspect]
This last result shows that the minimum of x is -6.84... and it occurs at t = -9.6, and the maximum is 3.60.... and it occurs at t = -6.4.  Similarly for the y numbers.  We see indeed that both x and y range outside the plotting window.  To graph all of the points calculated, we simply reset plrange and plot again.
:[font = input; preserveAspect]
plrange = {{-7,7},{-7,7}};
:[font = input; preserveAspect]
graph9 = phaser[sol3];
:[font = text; inactive; preserveAspect]
Integrating Both Directions in Time

     Another way of producing a solution which goes both ways in time from the initial state is to set the flag bothdirflag to True and then integrate.
;[s]
2:0,1;37,0;189,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
bothdirflag = True;
:[font = input; preserveAspect]
sol4 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
plot1 = phaser[sol4];
:[font = text; inactive; preserveAspect]
This gives us the same graph we constructed earlier by piecing together the two solutions.
:[font = text; inactive; preserveAspect]
Checking System Parameters

     At this point we have changed a number of the parameters from default settings.  We can check our present settings with intreport (integration parameters), plotreport (plotting parameters), or sysreport (system parameters).  (Or you can execute all three of these with parmreport.)
;[s]
2:0,1;28,0;315,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
intreport
:[font = input; preserveAspect]
plotreport
:[font = input; preserveAspect]
sysreport
:[font = input; preserveAspect]
parmreport
:[font = text; inactive; preserveAspect]
Naming the System

     The sysreport reminds us that we haven't named our system.  Let's do that now.
;[s]
2:0,1;19,0;103,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
sysname = "Damped Oscillator";
:[font = text; inactive; preserveAspect]
Controlling Plot Appearance

     Now let's look at a few variations in plot appearance, produced by our choices of some of the plot control variables.  Let's redo the last phase plot with dots rather than connected lines.  Because we have given the system a name, that name will now be part of the plot title.
;[s]
2:0,1;29,0;311,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
pointcon = False;
:[font = input; preserveAspect]
plot2 = phaser[sol4];
:[font = text; inactive; preserveAspect]
     These dots are constructed at equal time intervals (the spacing h), so that their density gives some indication of orbital velocity.  We can change the size of the dots.  The present (default) size is 0.005.  Let's use a larger dot.
:[font = input; preserveAspect]
ptsize = 0.01;
:[font = input; preserveAspect]
plot3 = phaser[sol4];
:[font = text; inactive; preserveAspect]
     Now we go back to a connected line, but thicker than before.
:[font = input; preserveAspect]
pointcon = True;
:[font = input; preserveAspect]
lnthick = 0.01;
:[font = input; preserveAspect]
plot4 = phaser[sol4];
:[font = text; inactive; preserveAspect]
     Let's now return to the default values of the plot control variables, by using plotreset, and then check the values with plotreport.
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plotreport
:[font = text; inactive; preserveAspect]
Selecting a Subset of the Solution

     The solution sol4 is defined on the time interval {-10,10}.  We can easily establish this by applying trange to sol4.
;[s]
2:0,1;36,0;159,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
trange[sol4]
:[font = text; inactive; preserveAspect]
     Sometimes we wish to deal with a solution over only part of the time range for which it was calculated.  The function subsol lets us select a subset of the solution based on the time range.  Let's use this to plot sol4 from t = 3 to t = 7.  
:[font = input; preserveAspect]
plrange = {{0,10},{-0.75,0.75}};
:[font = input; preserveAspect]
asprat = 0.5;
:[font = input; preserveAspect]
plot5 = timeplot[subsol[sol4,{3,7}],1];
:[font = text; inactive; preserveAspect]
Adding Version Numbers to Your Output

     The command sysid returns the version numbers of Dynamical Systems and Mathematica.  In the remaining tutorials, it will be the first command executed.
;[s]
4:0,1;39,0;115,2;126,0;196,-1;
3:2,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;1,13,10,Courier,2,12,0,0,0;
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Redo some or all of the above calculations for different values of the damping constant -- for example, eps = 0.05 (very lightly damped), eps = 1.0 (critically damped), and eps = 2.0 (overdamped).  
;[s]
2:0,1;10,0;214,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
