(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 11
;[s]
1:0,1;30,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Liapunov Functions
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     classify2D, liaparmval, liaparmvec, liapcontours, liapsign, liapsignseq, orbdt, orbdtval, parmval, parmvec, plotreset, plrange, portrait, setparm, setstate, slopevec, statevec, sysid, and sysname.   
;[s]
2:0,1;47,0;252,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     In this tutorial, we use Liapunov functions to look at the stability of some planar equilibria.  The routines demonstrated here do not help in the selection of a trial form for a Liapunov function, but they do allow a quick graphical check on the sign of either the function or its orbital derivative.  As examples, we use two simple nonlinear systems for which linearization does not yield a definite answer on the stability question.  Both systems are centers in linear theory.     
;[s]
2:0,1;46,0;536,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
First Example

     We define a simple nonlinear system with one equilibrium, at x = y = 0. 
;[s]
2:0,1;15,0;93,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{a}];
:[font = input; preserveAspect]
slopevec = {-2*y-x^3, a*x - y^3};
:[font = input; preserveAspect]
parmval = {1};
:[font = input; preserveAspect]
sysname = "Liap1";
:[font = text; inactive; preserveAspect]
     We first try classify2D.
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
Thus the linearized system is a stable center, so there is no conclusion about the stability of the nonlinear system.  We now try to find a Liapunov function V.  We can establish stability of the equilibrium if we find a V which (1) is positive definite in a deleted neighborhood of the origin and which (2) has a negative definite orbital derivative in a deleted neighborhood of the origin.  Liapunov functions are defined as expressions in the state variables and any parameters that we wish to include.  We try a simple quadratic function with one parameter.   
:[font = input; preserveAspect]
Vliap = x*x + alpha*y*y; 
:[font = text; inactive; preserveAspect]
This is clearly positive definite for any positive alpha.  We next declare the parameter alpha as a Liapunov parameter.
:[font = input; preserveAspect]
liaparmvec = {alpha};
:[font = input; preserveAspect]
liaparmval = {1};
:[font = text; inactive; preserveAspect]
Now we look at the orbital derivative of this function.
:[font = input; preserveAspect]
orbdt[Vliap]
:[font = text; inactive; preserveAspect]
To get the orbital derivative with the current system parameters substituted, we use orbdtval.
:[font = input; preserveAspect]
orbdtval[Vliap]
:[font = text; inactive; preserveAspect]
We see that a and alpha have been replaced by their present values (1 in both cases).  
:[font = text; inactive; preserveAspect]
     To get a quick look at the sign of the orbital derivative, we use the function liapsign, which will give us a contour with regions of positive function in white, negative in grey.  This routine automatically substitutes current values of both system and Liapunov parameters.  
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
plrange = {{-1.5,1.5},{-1.5,1.5}};
:[font = input; preserveAspect]
liapsign[orbdt[Vliap]];
:[font = text; inactive; preserveAspect]
     We see that this is not a suitable Liapunov function because the orbital derivative takes on both signs.  We now use the function liapsignseq to construct a sequence of such graphs, for a sequence of values of the parameter in the Liapunov function.  We try the values alpha = 1, 2, and 3.
:[font = input; preserveAspect]
parmlist = {1,2,3};
:[font = input; preserveAspect]
liapsignseq[parmlist,orbdt[Vliap]];
:[font = text; inactive; preserveAspect]
     Within the limits of the graphical resolution, it looks like alpha = 2 may work.  Let's see if we can verify this analytically.
:[font = input; preserveAspect]
liaparmval = {2};
:[font = input; preserveAspect]
orbdtval[Vliap] 
:[font = input; preserveAspect]
Simplify[%]
:[font = text; inactive; preserveAspect]
     Now we have shown analytically that alpha = 2 gives us a valid Liapunov function, and the equilibrium at {0,0} is therefore strictly stable.  In fact the analytical formulas show that the equilibrium is a global attractor for the system.  
:[font = text; inactive; preserveAspect]
     We can look at the contours of both the Liapunov function and its orbital derivative by using the plotting function liapcontours.
:[font = input; preserveAspect]
liapcontours[Vliap];
:[font = input; preserveAspect]
liapcontours[orbdt[Vliap]];
:[font = text; inactive; preserveAspect]
     Before leaving this example, lets see what the solution looks like near the equilibrium.  We look at a phase portrait with four different initial conditions.
:[font = input; preserveAspect]
intlist = {{1,1},{-1,1},{-1,-1},{1,-1}};
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 300; 
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
portrait[intlist,t0,h,nsteps,1,2];
:[font = text; inactive; preserveAspect]
     Now we see that the equilibrium is a nonlinear spiral.  If we continued the integration the orbits would eventually approach the origin, but the process is very slow because the approach is driven by terms which are cubic in the distance from the origin.
:[font = text; inactive; preserveAspect]
Second Example

      In this example, we consider a simple nonlinear system without any parameters.   
;[s]
2:0,1;16,0;104,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{}];
:[font = input; preserveAspect]
parmval = {};
:[font = input; preserveAspect]
slopevec = {y-x*(x^2+y^2)-5*(x*y)^2,-x-y*(x^2+y^2)};
:[font = text; inactive; preserveAspect]
We start by looking at equilibrium by linearization.
:[font = input; preserveAspect]
classify2D[{0,0}]
:[font = text; inactive; preserveAspect]
As before we get a linear center, which is indeterminate for our nonlinear system.  We try a simple Liapunov function.
:[font = input; preserveAspect]
Vliap2 = x^2+y^2;
:[font = input; preserveAspect]
liaparmvec = {};
:[font = input; preserveAspect]
liaparmval = {};
:[font = text; inactive; preserveAspect]
Now we look at the sign of the orbital derivative.
:[font = input; preserveAspect]
orbdt[Vliap2]
:[font = input; preserveAspect]
Simplify[%]
:[font = input; preserveAspect]
plrange = {{-2,2},{-2,2}};
:[font = input; preserveAspect]
liapsign[orbdt[Vliap2]];
:[font = text; inactive; preserveAspect]
     We see that the orbital derivative is not negative everywhere.  However, it is negative definite in a neighborhood of the origin, so this establishes the local strict stability of the equilibrium there.  This calculation leaves open the question of whether the origin is a global attractor for the system.  Lets look for other equilibria.   
:[font = input; preserveAspect]
othereq = nfindpolyeq
:[font = text; inactive; preserveAspect]
We see that there are two other real equilibrium points.  We check their stability.
:[font = input; preserveAspect]
classify2D[othereq[[1]]]
:[font = input; preserveAspect]
classify2D[othereq[[2]]]
:[font = text; inactive; preserveAspect]
Thus the equilibrium at {-1.28523,0.628076} is also an attractor.
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     This problem is taken from Chapter 10 of Nonlinear Ordinary Differential Equations,(second edition), D.W. Jordan and P. Smith, Oxford Press, 1987.  Consider the system defined by 
statevec = {x,y}, slopevec = {-x^3 + y^4, -y^3 + y^4}.  Show that linearization leads to no conclusion for the stability of the origin.  Find a Liapunov function which proves stability.  Use liapsign to check the sign of the orbital derivative.      
;[s]
4:0,1;10,0;56,1;97,0;446,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
^*)
