(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 2
;[s]
2:0,1;28,0;29,-1;
2:1,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Integration and Plotting (3D)
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial
;[s]
1:0,1;46,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     animate, asprat, boxrat, integrate, intreset, lastt, lastx, parmval, parmvec, period, phaseplot, phaseplot3D, phaser3D, plotreset, rotphaseplot3D, setparm, setstate, slopevec, statevec, viewpt.   
:[font = text; inactive; preserveAspect]
Description of System Used in This Tutorial

     The system used here is known as the Rossler system.  It is a three-dimensional, autonomous, nonlinear system and it exhibits a period-doubling route to chaos.  Some of the periodic solutions -- but not the chaotic solutions -- will be considered here.
;[s]
2:0,1;45,0;303,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
References

     The Rossler system is presented in many books.  Two brief but very useful discussions are those in Nonlinear Dynamics and Chaos, S.H. Strogatz, Addison-Wesley, 1994, pp. Section 10.6, and Chaos and Fractals, H.-O. Peitgen, H. Jurgens, D. Saupe, Springer-Verlag, 1992, Section 12.3.
;[s]
6:0,1;12,0;116,1;144,0;205,1;223,0;299,-1;
2:3,13,10,Courier,0,12,0,0,0;3,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We denote the three state variables by x, y, and z.  The system contains three parameters, denoted by a, b, and c.
;[s]
2:0,1;19,0;139,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{a,b,c}];
:[font = input; preserveAspect]
slopevec = {-y-z,x+a*y,b+z*(x-c)};
:[font = input; preserveAspect]
parmval = {0.2,0.2,2.0};
:[font = text; inactive; preserveAspect]
     This is a well-studied system, and it is known that the system with the above parameter values has a stable limit cycle solution.  We see if we can find that limit cycle.  First we reset plotting parameters and integration flags to the default values.  
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
intreset;
:[font = text; inactive; preserveAspect]
Integration Parameters

     We set the initial condition, the initial time, the time step, and the number of time steps.
;[s]
2:0,1;24,0;122,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
initvec = {1,1,1};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.025;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = text; inactive; preserveAspect]
Integration and 3D Phase Plot

     We carry out the integration.  The probability is zero that our randomly chosen initial condition is on the limit cycle, so we expect to do some preliminary integrations to get through the transient approach to the limit cycle.
;[s]
2:0,1;31,0;264,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
sol1 = integrate[initvec,t0,h,nsteps];
:[font = text; inactive; preserveAspect]
     We use the three-dimensional phase plot routine to view this solution.     
:[font = input; preserveAspect]
graph1 = phaseplot3D[sol1,1,2,3];
:[font = text; inactive; preserveAspect]
Controlling Plot Appearance

     It looks like there is some possibility of a limit cycle (plus transient), but we will have to keep integrating to be sure.  Before we do that, let's improve the view.  The box is rather squashed down.  The variable boxrat controls this.  The present value is
;[s]
2:0,1;29,0;294,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
boxrat
:[font = text; inactive; preserveAspect]
This value of Automatic means that the box is scaled by equal lengths for equal increments of the variables.  We can change this to a more useful scaling by setting boxrat to a new value.  We choose equal x and y sides, and we choose the height in to be 1.5 times the width.
:[font = input; preserveAspect]
boxrat = {1,1,1.5};
:[font = input; preserveAspect]
graph1stretched = phaseplot3D[sol1,1,2,3];
:[font = text; inactive; preserveAspect]
     Maybe we stretched it a bit too much.  Let's go to a cube.
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
graph1cube = phaseplot3D[sol1,1,2,3];
:[font = text; inactive; preserveAspect]
This is better.  Now let's look at the other variable which affects the appearance of 3D plots, namely viewpt, which defines the position from which the 3D object is viewed.  The present (default) setting is
:[font = input; preserveAspect]
viewpt
:[font = text; inactive; preserveAspect]
By choosing smaller numbers (a closer viewpoint), we can emphasize the perspective more.
:[font = input; preserveAspect]
viewpt = {4,-6,5};
:[font = input; preserveAspect]
graph1close = phaseplot3D[sol1,1,2,3];
:[font = text; inactive; preserveAspect]
We return to the default viewpoint.
:[font = input; preserveAspect]
viewpt = {13,-24,20};
:[font = text; inactive; preserveAspect]
Continuation of Integration

     Now we continue the integration from the last point of sol1, in our search for the limit cycle.  
;[s]
2:0,1;29,0;132,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
sol2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
graph2 = phaseplot3D[sol2,1,2,3];
:[font = text; inactive; preserveAspect]
     This looks like a limit cycle.  The slight thickening, especially on the upper part, suggests we are not quite there, so we integrate once more.  
:[font = input; preserveAspect]
sol3 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
graph3 = phaser3D[sol3];
:[font = text; inactive; preserveAspect]
In this last graph construction, we used phaser3D, which is a shortcut for phaseplot3D in which the values i = 1, j = 2, k = 3 are supplied automatically.
  
		   Now we clearly have the limit cycle.  We find its period by using the function period.
:[font = input; preserveAspect]
period[sol3]
:[font = text; inactive; preserveAspect]
     Thus the period is 5.7 seconds.
:[font = text; inactive; preserveAspect]
Phase Plots in 2D
;[s]
2:0,1;17,0;18,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We can get projected 2D views of this 3D limit cycle by using phaseplot.  We construct all three projections.  We first set the aspect ratio to 1.0.
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
graphxyproj1 = phaseplot[sol3,1,2];
:[font = input; preserveAspect]
graphxzproj2 = phaseplot[sol3,1,3];
:[font = input; preserveAspect]
graphyzproj3 = phaseplot[sol3,2,3];
:[font = text; inactive; preserveAspect]
Rotation and Animation of 3D Phase Plots

     To get a different 3D view, let's rotate the 3D graph 90 degrees about the z-axis.
;[s]
2:0,1;42,0;130,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
graph4 = rotphaseplot3D[sol3,1,2,3,90];
:[font = text; inactive; preserveAspect]
     To get a much better look at the 3D structure, we can create a series of graphs by animate.  After the graphs are constructed, we select them and then choose Animate Selected Graphs from the Graph menu.  We construct a sequence of 11 graphs.  (If you have the time, patience, and memory, a sequence of 30 or so graphs will give an outstanding animation.)
:[font = input; preserveAspect]
animate[sol3,1,2,3,11];
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     As an exercise, try repeating the entire sequence of calculations for the parameter values parmval = {0.2,0.2,3.0}.  You might need to use a smaller time step as well as more time steps.  You should see an interesting change in the limit cycle solution.
;[s]
2:0,1;10,0;269,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
