(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 5
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Comparison of Integration Methods
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, fastflag, integrate, intreset, maxstepflag, parmval, parmvec, phaseplot, plotreset, rangeflag, ranger, setparm, setstate, slopevec, staterange, statevec, sysid, and sysname.   
;[s]
2:0,1;47,0;237,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     We use here the Lorenz equations as a test case for the various integration methods available in this package.  The four methods of integrating, in order from fastest to slowest, are (1) NDSolve without a maximum step size, (2) NDSolve with a maximum step size, (3) fourth order Runge-Kutta without range checking, and (4) fourth order Runge-Kutta with range checking.  
;[s]
2:0,1;46,0;422,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Reference 

     Almost every text on dynamical systems has material on the Lorenz equations.  A very accessible treatment is given in Chapter 9 of Nonlinear Dynamics and Chaos, S.H. Strogatz, Addison-Wesley, 1994.  See Tutorial 12 for a more systematic look at the Lorenz equations.
;[s]
4:0,1;9,0;148,1;176,0;284,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We denote the three state variables of the Lorenz system by x, y, and z.  The parameters of the system are sigma, r, and b.  The parameter values selected are such that the solutions are chaotic.  Integration defaults are set by intreset, plotting defaults by plotreset.  The aspect ratio for the phase plots is set to 1.0. 
;[s]
2:0,1;19,0;349,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
sysname = "Lorenz";
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{sigma,r,b}];
:[font = input; preserveAspect]
slopevec = {sigma*(y-x),r*x-y-x*z,x*y-b*z};
:[font = input; preserveAspect]
parmval = {10.0,28.0,8/3};
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = text; inactive; preserveAspect]
Initial Values and Integration Parameters

     The initial condition is arbitrary in the sense that any reasonable initial condition will produce an orbit which rapidly goes to the chaotic attractor.  The step size is sufficiently small to give smooth solution curves.  In every case we integrate for 2000 steps.
;[s]
2:0,1;43,0;314,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
t0 = 0;
:[font = input; preserveAspect]
initialvec = {0.0, 1.0, 0.0};
:[font = input; preserveAspect]
h = 0.015;
:[font = input; preserveAspect]
nsteps = 2000;
:[font = text; inactive; preserveAspect]
NDSolve Without Maximum Step Size

     Our first integration technique is NDSolve without a maximum step size.  We get this by setting fastflag = True and maxstepflag = False.  We using Timing to get a benchmark for speed.  
;[s]
2:0,1;35,0;226,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
fastflag = True;
:[font = input; preserveAspect]
maxstepflag = False;
:[font = input; preserveAspect]
Timing[lorenz1 = integrate[initialvec,t0,h,nsteps];]
:[font = text; inactive; preserveAspect]
     To get a quick look at the solution, we construct a projection of the phase plot onto the xy plane.
:[font = input; preserveAspect]
xygraph1 = phaseplot[lorenz1,1,2];
:[font = text; inactive; preserveAspect]
NDSolve With Maximum Step Size

     Our second integration technique is NDSolve with a maximum step size.  We get this by setting fastflag = True and maxstepflag = True.  This last restricts the step size to be no larger than our h chosen earlier.  
;[s]
2:0,1;32,0;251,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
fastflag = True;
:[font = input; preserveAspect]
maxstepflag = True;
:[font = input; preserveAspect]
Timing[lorenz2 = integrate[initialvec,t0,h,nsteps];]
:[font = input; preserveAspect]
xygraph2 = phaseplot[lorenz2,1,2];
:[font = text; inactive; preserveAspect]
Runge-Kutta Without Range Checking

     Our third integration technique is the fourth order Runge-Kutta without range checking.  We get this by setting fastflag = False and rangeflag = False.  
;[s]
2:0,1;36,0;195,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
fastflag = False;
:[font = input; preserveAspect]
rangeflag = False;
:[font = input; preserveAspect]
Timing[lorenz3 = integrate[initialvec,t0,h,nsteps];]
:[font = input; preserveAspect]
xygraph3 = phaseplot[lorenz3,1,2];
:[font = text; inactive; preserveAspect]
Runge-Kutta With Range Checking

     Our fourth integration technique is the fourth order Runge-Kutta with range checking.  We get this by setting fastflag = False and rangeflag = True.  We also have to set the limits for the range in the variable ranger.  To get an appropriate range, we use staterange on the solution just calculated.  In this particular case, range checking is not necessary because the solutions of the Lorenz equations are bounded.  Range checking is helpful in preventing overflow and system crashes when we are attempting to construct partial orbits in a system with unbounded solutions.   
;[s]
2:0,1;33,0;616,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
staterange[lorenz3]
:[font = input; preserveAspect]
ranger = {{-30,30},{-30,30},{0,50}};
:[font = input; preserveAspect]
fastflag = False;
:[font = input; preserveAspect]
rangeflag = True;
:[font = input; preserveAspect]
Timing[lorenz4 = integrate[initialvec,t0,h,nsteps];]
:[font = input; preserveAspect]
xygraph4 = phaseplot[lorenz4,1,2];
:[font = text; inactive; preserveAspect]
Comment on the Graphs

     If you look closely at the four graphs, you will see that the first three are all slightly different.  This does NOT necessarily mean that the integrations are inaccurate.  In a chaotic system, even the smallest differences in two orbits will eventually lead to observable differences between them.  The different numerical algorithms produce orbits which differ -- very slightly at first, and then significantly as the integration goes on.  However, all four of the calculated orbits are on the chaotic attractor, and each gives a valid picture of the attractor.
;[s]
2:0,1;23,0;592,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Compare the time plots of z versus t for the four solutions and verify that the first three are different.  Why are the third and fourth solutions the same?
;[s]
2:0,1;10,0;172,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
