(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  36, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  28, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  24, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  20, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  18, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  14, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Courier"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, B65535, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, G65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
DYNAMICAL SYSTEMS TUTORIAL 6
;[s]
1:0,1;29,-1;
2:0,37,27,Times,1,36,0,0,0;1,29,21,Times,1,28,0,0,0;
:[font = subtitle; inactive; preserveAspect]
Periodic Solutions
of
Autonomous Systems
:[font = input; preserveAspect]
sysid
:[font = text; inactive; preserveAspect]
Functions and Variables Used in This Tutorial

     asprat, axon, axorg, div, dival, integrate, intreset, joinsol, lastt, lastx, limcyc, parmval, parmvec, period, phaseplot, phaser, phaser3D, plotreset, plrange, poinclist, poincmap, poincminus, poincmapopt3D, poincmap3D, poincplane, poincplus, poincptsize, restoresys, savesys, setparm, setstate, show, signcontour, slopevec, statevec, and sysreport.   
;[s]
2:0,1;47,0;405,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
Description of Systems Used in This Tutorial

     We use here three different systems with periodic solutions:  the undamped Duffing equation to illustrate a nonlinear center, the van der Pol equation to illustrate a 2D limit cycle, and the Rssler equations to illustrate a 3D limit cycle.  In addition to calculating and plotting the solutions and finding the periods, we construct several Poincare maps.  We also illustrate the use of the slope divergence to learn something about the location of periodic solutions (Bendixson test).
;[s]
2:0,1;46,0;538,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
References

     The three systems used here for examples are discussed in many books on dynamical systems.  Introductory treatments of all three are given in Nonlinear Dynamical Systems and Chaos, S.H. Strogatz, Addison-Wesley, 1994, Chapter 7 (van der Pol and Duffing) and Section 10.6 (Rossler).
;[s]
4:0,1;12,0;159,1;196,0;299,-1;
2:2,13,10,Courier,0,12,0,0,0;2,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
System Definition

     We define all three systems here and then save them by name. The state variables are x and y for the Duffing and van der Pol systems, and x,y, and z for the Rossler system.  Each system has one or more parameters, for which we take typical values.
;[s]
2:0,1;19,0;272,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
First the Rossler equations.
:[font = input; preserveAspect]
setstate[{x,y,z}];
:[font = input; preserveAspect]
setparm[{a,b,c}];
:[font = input; preserveAspect]
slopevec = {-y-z,x+a*y,b+z*(x-c)};
:[font = input; preserveAspect]
parmval = {0.2,0.2,2.0};
:[font = input; preserveAspect]
savesys[Rossler];
:[font = text; inactive; preserveAspect]
Now the van der Pol equation.
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{mu}];
:[font = input; preserveAspect]
slopevec = {y, -x -mu*(x*x-1)*y};
:[font = input; preserveAspect]
parmval = {2};
:[font = input; preserveAspect]
savesys[vanderPol];
:[font = text; inactive; preserveAspect]
Now the undamped Duffing equation.
:[font = input; preserveAspect]
setstate[{x,y}];
:[font = input; preserveAspect]
setparm[{a}];
:[font = input; preserveAspect]
slopevec = {y,-x-a*x^3};
:[font = input; preserveAspect]
parmval = {1};
:[font = input; preserveAspect]
savesys[Duffing];
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = text; inactive; preserveAspect]
Duffing Equation

     All of the solutions of the undamped Duffing equation are periodic.  Here we look briefly at the dependence of the period on amplitude, by considering three different solutions with different amplitudes.  
;[s]
2:0,1;18,0;229,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
initvec = {0.2,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.05;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
sol1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph1 = phaser[sol1];
:[font = input; preserveAspect]
period[sol1]
:[font = text; inactive; preserveAspect]
     We see several interesting things from these results.  The amplitude ranges from -0.2 to 0.2, and this is small, in the sense that the cubic force term is much smaller than the linear force term.  Thus this oscillator is behaving like a linear oscillator.  We see that also from the circular orbit (which is the orbit the system would have without the cubic term), and the period which is 6.2 (to within one spacing h = 0.05).  Without the cubic term, the period would be exactly 2 Pi, so we see the period is very slightly shortened.  Now we go to a larger amplitude.
:[font = input; preserveAspect]
initvec = {1.0,0.0};
:[font = input; preserveAspect]
sol2 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph2 = phaser[sol2];
:[font = input; preserveAspect]
period[sol2]
:[font = text; inactive; preserveAspect]
     Now there is a oblong shape to the curve, and the period is considerably shorter.  The cubic force is larger in this amplitude range, and the larger restoring force shortens the period.
:[font = text; inactive; preserveAspect]
     We consider one last case, with another factor of 5 increase in the amplitude.
:[font = input; preserveAspect]
initvec = {5.0,0.0};
:[font = input; preserveAspect]
sol3 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph3 = phaser[sol3];
:[font = text; inactive; preserveAspect]
     The curve is slightly thickened because our time step is really not quite small enough, so the repeat orbits don't quite match.  We can cure this with a smaller time step. 
:[font = input; preserveAspect]
h = 0.01;
:[font = input; preserveAspect]
nsteps = 200;
:[font = input; preserveAspect]
sol4 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
graph4 = phaser[sol4];
:[font = input; preserveAspect]
period[sol4]
:[font = text; inactive; preserveAspect]
     We see that the period is dramatically shortened, and that the orbit is even further elongated.  The true elongation is even more apparent on a plot which shows all three orbits.
:[font = input; preserveAspect]
plrange = {{-20,20},{-20,20}};
:[font = input; preserveAspect]
show[graph1,graph2, graph4];
:[font = text; inactive; preserveAspect]
The van der Pol Equation
;[s]
1:0,1;25,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We restore the van der Pol system and check to see that it has been correctly entered.
:[font = input; preserveAspect]
restoresys[vanderPol];
:[font = input; preserveAspect]
sysreport
:[font = text; inactive; preserveAspect]
Bendixson Test for the van der Pol Equation

     The Bendixson Test is based on the fact that the divergence of the slope vector must either be identically zero or change sign inside a periodic orbit.  Thus we can look at the sign of the divergence to determine constraints on the possible locations of periodic orbits.  We first calculate the divergence and then plot the sign.  The divergence is given by
;[s]
2:0,1;43,0;408,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
u = div[slopevec]
:[font = text; inactive; preserveAspect]
If we want the current parameter value to be substituted automatically, we use dival instead of div.
:[font = input; preserveAspect]
v = dival[slopevec]
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5}};
:[font = text; inactive; preserveAspect]
Now we use the routine signcontour, which shows white regions for positive, grey regions for negative.
:[font = input; preserveAspect]
signcontour[v];
:[font = text; inactive; preserveAspect]
     Thus the divergence is positive in the white band between x = -1 and x = 1.  (A result easily seen from the above formula for dival[slopevec].)  The conclusion is that any periodic solution must encompass parts of both the white and grey regions.  We will verify that when we actually calculate the limit cycle.
:[font = text; inactive; preserveAspect]
Limit Cycle Solution of the van der Pol Equation

     As is well-known, this system has a unique limit cycle which is a global attractor.  We look at a few orbits to show the approach to the limit cycle.
;[s]
2:0,1;50,0;205,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5}};
:[font = input; preserveAspect]
initvec = {1.0,0.0};
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 400;
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
van1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
vangraph1 = phaser[van1];
:[font = text; inactive; preserveAspect]
     We didn't go quite far enough, so we continue the integration.
:[font = input; preserveAspect]
van2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
vangraph2 = phaser[van2];
:[font = text; inactive; preserveAspect]
     Now we have the limit cycle.  We find the period.
:[font = input; preserveAspect]
period[van2]
:[font = text; inactive; preserveAspect]
     Now we look at an approach from outside.
:[font = input; preserveAspect]
initvec = {3.0,0};
:[font = input; preserveAspect]
nsteps = 800;
:[font = input; preserveAspect]
van3 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
vangraph3 = phaser[van3];
:[font = text; inactive; preserveAspect]
     We can combine these graphs to see a little better the approach to the limit cycle.
:[font = input; preserveAspect]
show[vangraph1, vangraph2,vangraph3];
:[font = text; inactive; preserveAspect]
     If we wish to produce the pure limit cycle without the startup transient, we use the routine limcyc.  We do that starting at the same initial point {3.0,0.0}.
:[font = input; preserveAspect]
van4 = limcyc[initvec,t0,h,400];
:[font = input; preserveAspect]
vangraph4 = phaser[van4];
:[font = input; preserveAspect]
period[van4]
:[font = text; inactive; preserveAspect]
     This gives us the pure limit cycle.  It was necessary that initvec and nsteps be such that the cycle is reached in nsteps, starting from initvec.  This period and the earlier period agree to within the time step 0.02.
:[font = text; inactive; preserveAspect]
Poincare Map for the van der Pol Limit Cycle
;[s]
1:0,1;45,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     The Poincare map really isn't needed for this case because the phase plots show clearly how the cycle is approached.  However, we construct the map anyway as a simple exercise in using the Poincare map routines.  We take line x = y as the Poincare "plane," and we construct a new solution starting further from the cycle.  The first step is to simply construct a solution in the usual way. 
:[font = input; preserveAspect]
initvec = {0.1,0.0};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.02;
:[font = input; preserveAspect]
nsteps = 2000;
:[font = input; preserveAspect]
vanpoinc = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
vangraph5 = phaser[vanpoinc];
:[font = text; inactive; preserveAspect]
     Now we define the Poincare plane.
:[font = input; preserveAspect]
poincplane = {1.0,-1.0,0.0};
:[font = text; inactive; preserveAspect]
Next we use poinclist to generate from the solution vanpoinc a list of intersections of the orbit with the Poincare plane.  To see what this list looks like, we display the first five elements.
:[font = input; preserveAspect]
vanlist = poinclist[vanpoinc];
:[font = input; preserveAspect]
Take[vanlist,5]
:[font = text; inactive; preserveAspect]
Finally we construct the Poincare map from vanlist with the routine poincmap.
:[font = input; preserveAspect]
poincmap[vanlist,1,2];
:[font = text; inactive; preserveAspect]
     The approach to the limit cycle is so rapid that we see only three points in the Poincare map.  We see from the graph of the limit cycle that we would expect four points if the Poincare plane were the y-axis.  We try this. 
:[font = input; preserveAspect]
poincplane = {1.0,0.0,0.0};
:[font = input; preserveAspect]
vanlist2 = poinclist[vanpoinc];
:[font = input; preserveAspect]
axon = False;
:[font = input; preserveAspect]
poincmap[vanlist2,1,2];
:[font = text; inactive; preserveAspect]
     We do get the expected four points.  Rather than removing the axes to make the dots visible, we can either move the axes or make the dots larger.  We try each, starting with moving the axes by using axorg, which controls the position of the origin.
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5}};
:[font = input; preserveAspect]
axorg = {-5,-5};
:[font = input; preserveAspect]
axon = True;
:[font = input; preserveAspect]
asprat = 1.0;
:[font = input; preserveAspect]
poincmap[vanlist2,1,2];
:[font = text; inactive; preserveAspect]
     We can make the dots larger to be more visible.  Then we can restore the axes to the original position and still see them.
:[font = input; preserveAspect]
poincptsize = 0.02;
:[font = input; preserveAspect]
axorg = Automatic;
:[font = input; preserveAspect]
poincmap[vanlist2,1,2];
:[font = text; inactive; preserveAspect]
Limit Cycle Solution of the Rossler Equations
;[s]
1:0,1;46,-1;
2:0,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = text; inactive; preserveAspect]
     We begin by changing the current system to the Rossler equations.
:[font = input; preserveAspect]
restoresys[Rossler];
:[font = input; preserveAspect]
sysreport
:[font = text; inactive; preserveAspect]
     We reset the integration and plot defaults, and then set the integration parameters.
:[font = input; preserveAspect]
intreset;
:[font = input; preserveAspect]
plotreset;
:[font = input; preserveAspect]
poincptsize = 0.02;
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5},{0,5}};
:[font = input; preserveAspect]
initvec = {1,1,1};
:[font = input; preserveAspect]
t0 = 0.0;
:[font = input; preserveAspect]
h = 0.025;
:[font = input; preserveAspect]
nsteps = 1000;
:[font = input; preserveAspect]
ross1 = integrate[initvec,t0,h,nsteps];
:[font = input; preserveAspect]
boxrat = {1,1,1};
:[font = input; preserveAspect]
rossgraph1 = phaser3D[ross1];
:[font = text; inactive; preserveAspect]
     We continue the integration.
:[font = input; preserveAspect]
ross2 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
rossgraph2 = phaser3D[ross2];
:[font = text; inactive; preserveAspect]
     This is very close to a pure limit cycle, though the curve is still a little thick, suggesting some transients remain.  We integrate once more.
:[font = input; preserveAspect]
ross3 = integrate[lastx,lastt,h,nsteps];
:[font = input; preserveAspect]
rossgraph3 = phaser3D[ross3];
:[font = text; inactive; preserveAspect]
     This looks like a pure limit cycle.  Let's find the period.
:[font = input; preserveAspect]
period[ross3]
:[font = text; inactive; preserveAspect]
     Now we join all of these solutions into one big solution, and construct a Poincare map for that joined solution.  We use the plane z = 1 for the Poincare plane.
:[font = input; preserveAspect]
bigross = joinsol[ross1,joinsol[ross2,ross3]];
:[font = input; preserveAspect]
poincplane = {0,0,1,-1};
:[font = input; preserveAspect]
rosslist = poinclist[bigross];
:[font = input; preserveAspect]
poincmap3D[rosslist,1,2,3];
:[font = text; inactive; preserveAspect]
     Now we choose a different Poincare plane -- namely, 2x+y+3z = 4.  We also change the viewpoint. 
:[font = input; preserveAspect]
poincplane = {2,1,3,-4};
:[font = input; preserveAspect]
rosslist2 = poinclist[bigross];
:[font = input; preserveAspect]
viewpt = {12,-24,-2};
:[font = input; preserveAspect]
poincmap3D[rosslist2,1,2,3];
:[font = text; inactive; preserveAspect]
The Poincare plane and the viewpoint we have chosen have caused the points to be clumped together.  We can get a better view of the map by using poincmapopt3D, which automatically chooses a viewpoint along the negative normal to the Poincare plane.
:[font = input; preserveAspect]
poincmapopt3D[rosslist2];
:[font = text; inactive; preserveAspect]
     We can also construct a 2D view of the Poincare map by plotting the x and y components of rosslist.
:[font = input; preserveAspect]
plrange = {{-5,5},{-5,5}};
:[font = input; preserveAspect]
poincmap[rosslist,1,2];
:[font = text; inactive; preserveAspect]
     The above two Poincare maps show both the transients and the periodic solution.  The Poincare map for the periodic solution has a simpler form, which we exhibit by using the periodic solution ross3.
:[font = input; preserveAspect]
vanlist3 = poinclist[ross3];
:[font = input; preserveAspect]
poincmap[vanlist3,1,2];
:[font = text; inactive; preserveAspect]
     Now we see two points only in the Poincare map -- one for the upward intersection of the orbit with the plane, and one for the downward intersection.  We can split our list into upward and downward by using the functions poincplus and poincminus.  The crossings in the direction of the positive normal to the Poincare plane are given by poincplus, and the crossings in the negative normal direction are given by poincminus.  
:[font = input; preserveAspect]
poincmap[poincplus[vanlist3],1,2];
:[font = input; preserveAspect]
poincmap[poincminus[vanlist3],1,2];
:[font = text; inactive; preserveAspect; endGroup]
Exercise

     Construct Poincare maps (both transient and periodic) for the Rossler system when {a,b,c} = {0.2,0.2,3.0}.
;[s]
2:0,1;10,0;122,-1;
2:1,13,10,Courier,0,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
^*)
